#include lerp.lua

function init()
	if not HasKey("savegame.mod.bladetype") then
		SetInt("savegame.mod.bladetype", 4)
	end
	if not HasKey("savegame.mod.launchertype") then
		SetInt("savegame.mod.launchertype", 1)
	end
	if not HasKey("savegame.mod.cutaccuracy") then
		SetInt("savegame.mod.cutaccuracy", 4)
	end
	if not HasKey("savegame.mod.multiblade") then
		SetBool("savegame.mod.multiblade", false)
	end
	if not HasKey("savegame.mod.dontshowframeratewarning") then
		SetBool("savegame.mod.dontshowframeratewarning", false)
	end
	if not HasKey("savegame.mod.hasenabledmultiblade") then
		SetBool("savegame.mod.hasenabledmultiblade", false)
	end
    if not HasKey("savegame.mod.volume") then
        SetFloat("savegame.mod.volume", 2)  --It's easier if I keep it 0 to 2, I convert it anyways in the main code
    end
	if not HasKey("savegame.mod.modifier") then
		SetString("savegame.mod.modifier", "alt")
	end
	if not HasKey("savegame.mod.togglecutting") then
		SetString("savegame.mod.togglecutting", "mmb")
	end
	if not HasKey("savegame.mod.tiltleft") then
		SetString("savegame.mod.tiltleft", "leftarrow")
	end
	if not HasKey("savegame.mod.tiltright") then
		SetString("savegame.mod.tiltright", "rightarrow")
	end

	modifier = GetString("savegame.mod.modifier")
	tiltleft = GetString("savegame.mod.tiltleft")
	tiltright = GetString("savegame.mod.tiltright")
	togglecutting = GetString("savegame.mod.togglecutting")

	bladetypes = {
					{
						solo = "_red",
						inlauncher = "_redblade"
					},
					{
						solo = "_green",
						inlauncher = "_greenblade"
					},
					{
						solo = "_blue",
						inlauncher = "_blueblade"
					},
					{
						solo = "2_red",
						inlauncher = "_redblade2"
					},
					{
						solo = "2_green",
						inlauncher = "_greenblade2"
					},
					{
						solo = "2_blue",
						inlauncher = "_blueblade2"
					}
				}
	bladeindex = GetInt("savegame.mod.bladetype")
	launchertypes = {"_red", "_green", "_blue"}
	launcherindex = GetInt("savegame.mod.launchertype")
	launcherpathwithblade = "MOD/vox/launcher"..launchertypes[launcherindex]..bladetypes[bladeindex].inlauncher..".vox"
	launcherpathnoblade = "MOD/vox/launcher"..launchertypes[launcherindex]..".vox"
	bladepath = "MOD/vox/blade"..bladetypes[bladeindex].solo..".vox"

	notlaunched = true
	launchpower = 1
	launchtimer = {-5}
	nocutlaunchtimer = -5
	angle = 180
	charging = false
	cangrab = {false}
	bladedist = {0}
	realtilt = 0
	blade = {}
	lastbladedist = {}
	bladecentertransform = {}
	closestblade = blade[1]

	spinchange = {0}
	spin = {0}
	orbitoffset = {4}
	deletebladesfororbit = false
	bladerot = 0
	numingroup =			{0, 4,   8 ,  14,   22,   32,   44,   58,   74,   92,   9999}
	totalblades =			{0, 4,   12,  26,   48,   80,   124,  182,  256,  348,  9999}
	orbitdists = 			{0, 3.5, 6.5, 9.8,  13.5, 17.4, 21.6, 25.9, 30.5, 35.1, 40}
	bladeringspinoffset =	{0, 0.3, 0.6, 1.2,  2.2,  3.4,  5.1,  7.7,  10.9, 14.0, 18}
	bladerot = {0}

	launcherknockback = 0
	launcherknockbackvelocity = 0
	launchedlastframe = false

	tilttimer = 0
	tilt = 0

	grabtimer = 0
	pulltimer = 0
	catchtimer = 0
	cutsoundtimer = 0
	followswitchtimer = 0

	bladefollowmode = 1
	followmodes = {"Gravity Follow", "Rigid Follow", "Orbit"}
	launchvelocity = {}
	rigidfollowvelocity  = {}
	target = Vec(0,0,0)
	targettransform = Transform(Vec(0,0,0), QuatEuler(0,0,0))

	speedupval = 1
	speeduptimer = -10
	speedup = false

	angVel = 0

	multiblade = GetBool("savegame.mod.multiblade")

	cutaccuracy = GetInt("savegame.mod.cutaccuracy") + 1

	debug = false
	cinematic = false

	chargeloop = LoadLoop("MOD/snd/blade_chargeloop.ogg")
	shoot = LoadSound("MOD/snd/blade_shoot.ogg")
	catch = LoadSound("MOD/snd/blade_catch.ogg")
	spinloop =  LoadLoop("MOD/snd/blade_spin.ogg")
	cut = LoadSound("MOD/snd/blade_cut.ogg")
	bladespinvolume = {}

	framestotal = 0
	avgframerate = 0
	framewarningbrightness = 0
	frameratewarntimer = -5
	dontshowagain = GetBool("savegame.mod.dontshowframeratewarning")
	lastframetime = 0
	twoframesagotime = 0
	frames = {}
	stopbladetimer = 0
	showingwarning = false

    volume = GetFloat("savegame.mod.volume")*0.5

	options = false
	optionsshown = false
	optionsclosetimer = 0
	opacity = 0
	optionspage = 1

    expandbladeselect = false
    expandlauncherselect = false

    dropdownvertoffset = 60
    hoverblade = false
    hoverlauncher = false
    hovernumb = GetInt("savegame.mod.bladetype")
    hovernuml = GetInt("savegame.mod.launchertype")
    lasthovernumb = GetInt("savegame.mod.bladetype")
    lasthovernuml = GetInt("savegame.mod.launchertype")
    cachedlastimgb =  GetInt("savegame.mod.bladetype")
    cachedlastimgl =  GetInt("savegame.mod.launchertype")
    firsthoverb = true
    firsthoverl = true

    volume = GetFloat("savegame.mod.volume")*0.5

    clickedtimer = 0

	cameratilt = {}

    RegisterTool("blade_launcher", "Blade Launcher", launcherpathwithblade)
    RegisterTool("blade_launcher2", "Blade Launcher", "MOD/vox/invis.vox")
    SetBool("game.tool.blade_launcher.enabled", true)
    SetInt("game.tool.blade_launcher.ammo", 9991)
end

function round(val,v)
    return math.floor((val+(0.5*v))/v)*v	--Rounds val to the nearest v (ex: 11.43 to the nearest 0.1, which is 11.4), works with any v value (so you can do 11.43 to the nearest 1.25 which is 11.25)
end

function sign(val)
	if val == 0 then return 1
	else return val/math.abs(val) end
end

function tick(dt)
	if GetString("game.player.tool") == "blade_launcher2" and not switchBack then
		switchBack = true
	end

	if InputPressed("p") and debug then
		SetBool("savegame.mod.hasenabledmultiblade", false)
		SetBool("savegame.mod.dontshowframeratewarning", false)
	end

	if switchBack and not optionsshown then	--Borrowed from micro, runs after you catch the blade.
		RegisterTool("blade_launcher", "Blade Launcher", launcherpathwithblade)
		SetBool("game.tool.blade_launcher2.enabled", false)
		SetBool("game.tool.blade_launcher.enabled", true)
		SetString("game.player.tool","blade_launcher")
		switchBack = false
	end

	if GetTime() < 3 then
		framestotal = framestotal + 1
		avgframerate = framestotal/GetTime()
		--DebugWatch("avgframerate", avgframerate)
	end

	if debug then DebugWatch("mousedx", InputValue("mousedx")) end

	if GetString("game.player.tool") == "blade_launcher" or GetString("game.player.tool") == "blade_launcher2" then
		launcherheld = true

		if InputPressed("o") and not options and GetTime() > optionsclosetimer + 0.1 then
			options = true
			optionsshown = true
			optionstimer = GetTime()
			optionspage = 1
		end

		if GetBool("game.player.canusetool") then
			--if GetTime() < launchtimer + 0.35 then toolknockback = toolknockback + (GetTime()-launchtimer)*(0.00001/(((GetTime()-launchtimer)+0.035)^5)) end
			if tilting then sway = 0 else sway = 0.75 end
			if launchedlastframe then
				launcherknockbackvelocity = math.max(((math.abs(VecLength(GetBodyVelocity(blade[#blade]))/100)*10)^0.75)^1.1,0.3)
				launcherknockbackpullback = launcherknockbackvelocity*2
				if launcherknockback == 0 then launcherknockback = 0.1 end
				knockback = true
				knockbackspeedmod = 2
				--DebugWatch("first condition", 1)
				--DebugWatch("firstlauncherknockbackvelocity", launcherknockbackvelocity)
				--DebugWatch("launcherknockbackpullback", launcherknockbackpullback)
			end
			--DebugWatch("launchedlastframe", launchedlastframe)
			--DebugWatch("launcherknockback", round(launcherknockback, 0.1))
			--DebugWatch("launcherknockbackvelocity", round(launcherknockbackvelocity, 0.1))
			SetToolTransform(Transform(VecAdd(Vec(0.45,-0.385,-0.7+launcherknockback), Vec((0.45*math.sin(math.rad(realtilt)))/1,(-0.685*math.cos(math.rad(realtilt)))/1.4,0)), QuatEuler(5+(launcherknockback*20),-1,realtilt)), sway)
			launchedlastframe = false
			if #blade == nil or #blade == 0 then spamtimer = 0 else spamtimer = launchtimer[#blade] end
			if (InputDown("usetool") and (not launched or multiblade) and not pulling and not InputDown(modifier) and bladefollowmode ~= 3) or ((InputPressed("usetool") or (InputDown("usetool") and InputDown(modifier) and GetTime() > spamtimer + 0.1/((GetTimeStep()*60)^1.5))) and bladefollowmode == 3 and not charging) then 
				if launchpower < 3 then launchpower = launchpower + 0.05*dt*60 end
				charging = true
				PlayLoop(chargeloop, bladepos(), (launchpower/3)*volume) --(launchpower-1)/3
			elseif charging then
				PlaySound(shoot, bladepos(), ((0.5+((launchpower-1)/2))*volume)*0.65)
				bladespinvolume[#blade+1] = ((angVel/1000)^0.59)/6 - 0.1
				angVel = 0
				launched = true
				staticbladetransform = GetShapeWorldTransform(staticblade)
				if InputDown("up") then distadd = 0.5 else distadd = 0 end
				if #blade > 0 then spawnoffset = TransformToParentVec(GetPlayerCameraTransform(), Vec(0,0,-1.75 - 0.1*launchpower)) else spawnoffset = Vec(0,0,0) end
				bladetemp = Spawn("<body name='blade' tags='launchedblade unbreakable' pos='0.0 0.0 0.0' rot='90.0 0.0 0.0' dynamic='true'> <vox tags='launchedblade unbreakable' pos='0.0 0.0 0.0' density='1000' strength='100000' file='"..bladepath.."' scale='1'> </vox> </body>", Transform(VecAdd(staticbladetransform.pos, VecAdd(TransformToParentVec(staticbladetransform, Vec(0.575,0.575,0)), spawnoffset)), staticbladetransform.rot)) --TransformToParentVec(GetPlayerCameraTransform(), Vec(0,0,-0.75 + 0.1*launchpower))
				body = nil
				for i=1, #bladetemp do
					local body = bladetemp[i]
					local t = GetEntityType(body)
					if t == "body" and HasTag(body, "launchedblade") then
						blade[#blade+1] = body
						break
					end
				end
				SetBodyAngularVelocity(blade[#blade], TransformToParentVec(GetBodyTransform(blade[#blade]), Vec(0,30,0)))
				if realtilt > 0 then tiltcomp = 1*(realtilt/90) else tiltcomp = 0 end
				if InputDown("up") then SetBodyVelocity(blade[#blade], VecAdd(Vec(0,1,0), TransformToParentVec(GetPlayerCameraTransform(), Vec(-tiltcomp,-math.abs(realtilt/90),(-10*(launchpower^1.5))-8)))) else SetBodyVelocity(blade[#blade], VecAdd(Vec(0,1,0), TransformToParentVec(GetPlayerCameraTransform(), Vec(-tiltcomp,-math.abs(realtilt/90),-10*(launchpower^1.5))))) end
				launchvelocity[#blade] = VecLength(GetBodyVelocity(blade[#blade]))
				rigidfollowvelocity[#blade] = launchvelocity[#blade]
				if not multiblade then
					Delete(staticblade)
					RegisterTool("blade_launcher", "Blade Launcher", launcherpathnoblade)
				end
				launchedlastframe = true
				lastlaunchpower = launchpower
				launchpower = 1
				charging = false
				launchtimer[#blade] = GetTime()
				nocutlaunchtimer = GetTime()
				lastbladedist[#blade] = 0
				cangrab[#blade] = false
				if bladefollowmode == 3 then
					local look = {GetQuatEuler(GetPlayerCameraTransform().rot)} 
					spin[#blade] = look[2]+180
					bladerot[#blade] = 0
				end
			elseif (InputPressed("usetool") or (InputDown("usetool") and GetTime() > pulltimer + 0.3)) and launched and (not multiblade or InputDown(modifier)) and bladefollowmode ~= 3 then
				for i=1, #blade do
					force = -10*GetBodyMass(blade[i])
					ApplyBodyImpulse(blade[i], bladecentertransform[i].pos, VecAdd(Vec(0,GetBodyMass(blade[i])*(10.02/60),0), QuatRotateVec(QuatLookAt(bladecentertransform[i].pos, toolpos()), Vec(0,0,force))))
					pulltimer = GetTime()
					pulling = true
				end
			elseif InputReleased("usetool") then
				pulling = false
			end
			if (InputPressed("grab") and not InputDown(modifier)) or deletebladesfororbit then
				if not IsBodyDynamic(GetPlayerGrabBody()) then
					if launched then
						for i=1, (#blade) do
							Delete(blade[i])
						end
						local excessblades = FindBodies("launchedblade")
						Delete(excessblades)
						blade = {}
						lastbladedist = {}
						cangrab = {}
						bladespinvolume = {}
						launchvelocity = {}
						rigidfollowvelocity = {}
						spinchange = {}
						spin = {}
						orbitoffset = {}
						PlaySound(catch, bladepos(), 0.5*volume)
						RegisterTool("blade_launcher2", "Blade Launcher", launcherpathwithblade)
						SetBool("game.tool.blade_launcher.enabled", false)
						SetBool("game.tool.blade_launcher2.enabled", true)
						SetString("game.player.tool","blade_launcher2")
						switchBack = true
						launched = false
						grabtimer = GetTime()
					end
				end
				deletebladesfororbit = false
			end
			if InputDown("grab") and (GetTime() < grabtimer + 0.1 or GetPlayerGrabBody() ~= 0) then rmbstillheld = true elseif InputReleased("grab") then rmbstillheld = false end
			if InputDown("grab") and not grabstillheld then
				playervel = GetPlayerVelocity()
				SetPlayerTransform(Transform(GetPlayerTransform().pos, prevplayertransform.rot), true)
				if debug then 
					DebugWatch("delay", 0.6/(math.abs(InputValue("mousedx")/7)^1.5))
					DebugWatch("rawdelay", 0.6/math.abs(InputValue("mousedx")/7))
				end
				SetPlayerVelocity(playervel)
			else
				prevplayertransform = GetPlayerCameraTransform()
			end
			if ((InputDown(tiltleft) or InputPressed(tiltleft)) or (InputDown("grab") and InputValue("mousedx") < 0)) and ((GetTime() > tilttimer + 0.25 and (InputDown(tiltleft) or InputPressed(tiltleft))) or (GetTime() > tilttimer + 0.6/(math.abs(InputValue("mousedx")/7)^1.8) and InputDown("grab"))) and tilt < 90 and not rmbstillheld then
				tilt = tilt + 15
				tilttimer = GetTime()
			elseif ((InputDown(tiltright) or InputPressed(tiltright)) or (InputDown("grab") and InputValue("mousedx") > 0)) and ((GetTime() > tilttimer + 0.25 and (InputDown(tiltright) or InputPressed(tiltright))) or (GetTime() > tilttimer + 0.6/(math.abs(InputValue("mousedx")/7)^1.8) and InputDown("grab"))) and tilt > -90 and not rmbstillheld then
				tilt = tilt - 15
				tilttimer = GetTime()
			end
			if InputPressed(togglecutting) and off then off = false windingdown = false elseif InputPressed(togglecutting) then off = true windingdown = true end
			if InputDown(modifier) then
				SetBool('game.input.locktool', true)
				if InputValue("mousewheel") > 0.1 and GetTime() > followswitchtimer + 0.125 then
					bladefollowmode = bladefollowmode - 1
					if bladefollowmode == 0 then bladefollowmode = 3 deletebladesfororbit = true end
					if bladefollowmode == 2 then
						for i=1, #blade do
							rigidfollowvelocity[i] = VecLength(VecSub(GetBodyVelocity(blade[i]), GetPlayerVelocity()))
						end
					end
					followswitchtimer = GetTime()
				elseif InputValue("mousewheel") < -0.1 and GetTime() > followswitchtimer + 0.125 then
					bladefollowmode = bladefollowmode + 1
					if bladefollowmode == 4 then bladefollowmode = 1 end
					if bladefollowmode == 3 then deletebladesfororbit = true end
					if bladefollowmode == 2 then
						for i=1, #blade do
							rigidfollowvelocity[i] = VecLength(VecSub(GetBodyVelocity(blade[i]), GetPlayerVelocity()))
						end
					end
					followswitchtimer = GetTime()
				end
			end
			if cinematic and InputDown(modifier) then
				for i=1, 10 do
					offset = math.random(0, 180)
					bladeParticles(VecAdd(GetShapeWorldTransform(staticblade).pos, TransformToParentVec(GetShapeWorldTransform(staticblade), Vec(0.45,0.45,0))), 4, 4, 0)
				end
			end
		else
			SetToolTransform(Transform(Vec(0.55,-1.685,-0.5), QuatEuler(-3,-1,-3)), 0.75)
		end
		if launched then
			if GetPlayerVehicle() ~= 0 then vehicle = GetPlayerVehicle() target = TransformToParentPoint(GetVehicleTransform(vehicle), GetVehicleDriverPos(vehicle)) else target = toolpos() end
			for i=1, #blade do
				if VecLength(VecSub(target, GetBodyTransform(blade[i]).pos)) < VecLength(VecSub(target, GetBodyTransform(closestblade).pos)) then
					closestblade = blade[i]
					closestbladeindex = i
				end
				lastbladedist[i] = VecLength(VecSub(toolpos(), GetBodyTransform(closestblade).pos))
			end
			local i = closestbladeindex
			--DebugWatch("closestblade", i)
			if ((VecLength(VecSub(target, GetBodyTransform(closestblade).pos)) < 2 and GetPlayerVehicle() == 0) or (VecLength(VecSub(target, GetBodyTransform(closestblade).pos)) < 1.5 and GetPlayerVehicle() ~= 0)) and (GetTime() > launchtimer[i] + 0.25 or (lastbladedist[i] > VecLength(VecSub(target, GetBodyTransform(closestblade).pos)) and cangrab[i])) and bladefollowmode ~= 3 then
				SetPlayerVelocity(VecAdd(GetPlayerVelocity(), VecSub(VecScale(GetBodyVelocity(closestblade),0.5), GetPlayerVelocity())))
				Delete(closestblade)
				table.remove(blade, i)
				table.remove(lastbladedist, i)
				table.remove(cangrab, i)
				table.remove(bladespinvolume, i)
				table.remove(launchvelocity, i)
				table.remove(rigidfollowvelocity, i)
				PlaySound(catch, bladepos(), 0.5*volume)
				RegisterTool("blade_launcher2", "Blade Launcher", launcherpathwithblade)
				SetBool("game.tool.blade_launcher.enabled", false)
				SetBool("game.tool.blade_launcher2.enabled", true)
				SetString("game.player.tool","blade_launcher2")
				switchBack = true
				catchtimer = GetTime()
				if blade[1] == nil then launched = false end
			end
		end
		if debug then
			DebugWatch("power", launchpower)
			DebugWatch("vec", QuatRotateVec(QuatLookAt(bladecentertransform[i], toolpos()), Vec(0,0,-300)))
			DebugWatch("vel", GetBodyVelocity(blade))
			DebugWatch("pos", GetBodyTransform(blade).pos)
			DebugWatch("force", force)
			DebugWatch("dist", bladedist)
			DebugWatch("toolpos", toolpos())
			--DebugWatch("launchtimer", GetTime() - (launchtimer+1))
			DebugWatch("cangrab", cangrab)
			DebugWatch("mass", GetBodyMass(blade))
			DebugWatch("tilt", tilt)
			DebugWatch("speedup", speedup)
			DebugWatch("angVel", angVel)
			DebugWatch("targetval", round(1000*(launchpower^1.5)*speedupval, 100))
			DebugWatch("bladelength", #blade)
		end
		if bladeindex == 1 or bladeindex == 4 then r=1 g=0 b=0 elseif bladeindex == 2 or bladeindex == 5 then r=0 g=1 b=0 else r=0 g=0 b=1 end
		for i=1, #blade do
			if not IsBodyVisible(blade[i], 100000, true) or IsPointInWater(GetBodyTransform(blade[i]).pos) or IsPointInWater(GetPlayerCameraTransform().pos) then DrawBodyOutline(blade[i], r, g, b, 1) end
		end
		if not launched or multiblade then
			spinvolume = ((angVel/1000)^0.59)/6
			PlayLoop(spinloop, bladepos(), ((spinvolume*volume)^0.6))
		end
		if launched then
			for i=1, #blade do
				PlayLoop(spinloop, GetBodyTransform(blade[i]).pos, bladespinvolume[i]*volume)
			end
		end
		if bladefollowmode == 3 then lowfpsbladealignmentcompensation = math.max(1, math.min((60/(1/dt))^1.5, 4)) end
	elseif launcherheld then
		if launched then
			for i=1, #blade do
				Delete(blade[i])
			end
		end
		blade = {}
		lastbladedist = {}
		cangrab = {}
		bladespinvolume = {}
		launchvelocity = {}
		rigidfollowvelocity = {}
		spinchange = {}
		spin = {}
		orbitoffset = {}
		bladerot = {}
		RegisterTool("blade_launcher", "Blade Launcher", launcherpathwithblade)
		launched = false
		angVel = 0
	end
	-- old framerate helper for cutting big objects
	--frames[#frames+1] = dt
	--totalframes = 0
	--for i=1, #frames do
	--	totalframes = totalframes + frames[i]
	--end
	--avgframes = 1/(totalframes/#frames)
	----DebugWatch("avgframes", avgframes)
	----DebugWatch("dontshowagain", dontshowagainw6)
	--if #frames > 4 then table.remove(frames, 1) end
	--if avgframes <= 30 then
	--	--DebugWatch("stopblade")
	--	disableblade = true
	--	stopbladetimer = GetTime() + 1
	--elseif disableblade and GetTime() > stopbladetimer then
	--	disableblade = false
	--end
	if (InputPressed("x") or (InputDown("usetool") and InputDown("grab"))) and showingwarning then
		SetBool("savegame.mod.dontshowframeratewarning", true)
		dontshowagain = true
	end
end

function update(dt)
	if GetString("game.player.tool") == "blade_launcher" or GetString("game.player.tool") == "blade_launcher2" then
		if (not launched or multiblade) then
			if off then decel = 0.25 else decel = 1 end
			if (GetTime() < grabtimer + 0.5) or (GetTime() < catchtimer + 0.5) then accel = 0.5 else accel = 1 end
			if not off and angVel < round(1000*(launchpower^1.5)*speedupval, 100) and angVel ~= round(1000*(launchpower^1.5)*speedupval, 100) then angVel = angVel + 50*accel elseif ((angVel > round(1000*(launchpower^1.5)*speedupval, 100) + 10 and angVel ~= round(1000*(launchpower^1.5)*speedupval, 100)) or off) and angVel > 0 then angVel = angVel - 100*decel elseif not off then angVel = round(1000*(launchpower^1.5)*speedupval, 100) else angVel = 0 end
			angle = angle + (angVel*dt)^((launchpower*speedupval)^0.01) --to offset the effect where the blade turns 180/360 degrees every turn and looks still. --+ math.random(-1*(launchpower*speedupval)^2,1*(launchpower*speedupval)^2) 
			local b = GetToolBody()
			local voxSize = 0.05
			local attach = Transform(Vec(0.025, 0, -0.575))
			if body ~= b then
				body = b
				local shapes = GetBodyShapes(b)
				launchershape = shapes[1]
				staticblade = shapes[2] 
				bladeTransform = TransformToLocalTransform(attach, GetShapeLocalTransform(staticblade))
			end
			attach.rot = QuatEuler(0, angle, 0)
			t = TransformToParentTransform(attach, bladeTransform)
			SetShapeLocalTransform(staticblade, t)
		end
	end
	if not off and (not launched or (multiblade and VecLength(VecSub(target, GetBodyTransform(closestblade).pos)) > 2)) then
		local dynamicbodiestouching = {}
		local testpoint = {Vec(-0.6,0,0), Vec(-0.424,0,-0.424), Vec(0,0,-0.6), Vec(0.424,0,-0.424), Vec(0.6,0,0)}
		for i=1, 5 do
			QueryRequire("physical dynamic large")
			if i ~= 1 then
				for j=1, #dynamicbodiestouching do
					QueryRejectBody(dynamicbodiestouching[j])
				end
			end
			local refpoint = VecAdd(GetShapeWorldTransform(staticblade).pos, TransformToParentVec(GetShapeWorldTransform(staticblade), Vec(0.45,0.45,0)))
			dynamicbodiestouching = addtables(dynamicbodiestouching, QueryAabbBodies(VecAdd(refpoint, testpoint[i]), VecAdd(refpoint, VecAdd(testpoint[i], Vec(0.01,0.01,0.01)))))
		end
		if debug and #dynamicbodiestouching > 0 then
			DebugPrint("1. "..tabletostring(dynamicbodiestouching))
		end
		local totalbodies = #dynamicbodiestouching
		for i=1, totalbodies do
			local j = totalbodies - i + 1
			--local min, max = GetBodyBounds(dynamicbodiestouching[j])
			--local bodyvolume = round(math.abs(min[1] + max[1]) * math.abs(min[2] + max[2]) * math.abs(min[3] + max[3]), 1)
			if debug and #dynamicbodiestouching > 0 then
				DebugPrint((i+1)..". "..tabletostring(dynamicbodiestouching))
			end
			local bodymass = GetBodyMass(dynamicbodiestouching[j])
			if bodymass < 150000 or HasTag("launchedblade") then
				table.remove(dynamicbodiestouching, j)
			end
		end
		local biggestbodymass = 0
		for i=1, #dynamicbodiestouching do
			local bodymass = GetBodyMass(dynamicbodiestouching[i])
			if bodymass > biggestbodymass then
				biggestbodymass = bodymass
				if debug then DrawBodyOutline(dynamicbodiestouching[i], 1) end
			end
			if debug and #dynamicbodiestouching > 0 then
				DebugPrint((i+1)..".2. "..tabletostring(dynamicbodiestouching))
			end
		end
		if #dynamicbodiestouching > 0 then
			if debug then
				DebugWatch("touching", "yes, "..biggestbodymass)
				DebugPrint("final. "..tabletostring(dynamicbodiestouching))
			end
			disableblade = true
		else
			if debug then
				DebugWatch("touching", "no, "..biggestbodymass)
			end
			disableblade = false
		end
	end
	if knockback then
		if launcherknockback > 1.25 and launcherknockbackvelocity > 0 then
			launcherknockbackvelocity = 0
			launcherknockback = 1.25
		elseif launcherknockback <= 0.3 and launcherknockback > 0 and launcherknockbackvelocity < 0 then
			local arg1 = launcherknockbackvelocity/(1+(dt*2*(((lastlaunchpower^2)/5)^2.5)*(1/(launcherknockback*(lastlaunchpower/3)))))
			local arg2 = -1*dt*((5/lastlaunchpower)^1.5)*(((launcherknockback^0.25)+1)^4)
			launcherknockbackvelocity = math.min(arg1, arg2)
			launcherknockback = launcherknockback + launcherknockbackvelocity*dt*knockbackspeedmod
		--elseif launcherknockback <= 0.6 and launcherknockback > 0 and launcherknockbackvelocity < 0 then
		--	local arg1 = launcherknockbackvelocity/(1+((dt*2*(((lastlaunchpower^2)/5)^2.5)*(1/(launcherknockback*(lastlaunchpower/3))))/3))
		--	local arg2 = (-1*dt*((5/lastlaunchpower)^1.5)*(((launcherknockback^0.25)+1)^4))/2
		--	launcherknockbackvelocity = math.min(arg1, arg2)
		--	DebugWatch("arg1.2", arg1)
		--	DebugWatch("arg2.2", arg2)
		--	launcherknockback = launcherknockback + launcherknockbackvelocity*dt*knockbackspeedmod
		elseif launcherknockback >= 0 then
			launcherknockback = launcherknockback + launcherknockbackvelocity*dt*knockbackspeedmod
			launcherknockbackvelocity = launcherknockbackvelocity - launcherknockbackpullback*dt*knockbackspeedmod*(1.5/(launcherknockback+1))
		elseif launcherknockback < 0 then
			launcherknockback = 0
			launcherknockbackvelocity = 0
			launcherknockbackpullback = 0
			knockback = false
		end
	end
	if debug then
		--if spindebug == nil then throwaway,spindebug,throwaway = GetQuatEuler(GetPlayerCameraTransform().rot) end
		--if startspin == nil then startspin = spindebug end
		--spinchangedebug = math.deg((15*dt)/5)
		spindebug = spin[1] or 0 --spindebug + spinchangedebug
		local look = {GetQuatEuler(GetPlayerCameraTransform().rot)}
		DebugWatch("startspin", look[2])
		DebugCross(VecAdd(TransformToParentVec(Transform(GetPlayerCameraTransform().pos, QuatEuler(0,spindebug,0)), Vec(0,0,5)), GetPlayerCameraTransform().pos))
		local debuganchor = Transform(VecAdd(GetShapeWorldTransform(staticblade).pos, TransformToParentVec(GetShapeWorldTransform(staticblade), Vec(0.45,0.45,0))), GetShapeWorldTransform(staticblade).rot)
		DebugCross(VecAdd(debuganchor.pos, TransformToParentVec(tooltransform(), Vec(0,0,-0.6))), 0, 1, 1, 1)
		DebugCross(VecAdd(debuganchor.pos, TransformToParentVec(tooltransform(), Vec(-0.6,0,0))), 0, 1, 1, 1)
		DebugCross(VecAdd(debuganchor.pos, TransformToParentVec(tooltransform(), Vec(0.6,0,0))), 0, 1, 1, 1)
		DebugCross(VecAdd(debuganchor.pos, TransformToParentVec(tooltransform(), Vec(-0.424,0,-0.424))), 0, 1, 1, 1)
		DebugCross(VecAdd(debuganchor.pos, TransformToParentVec(tooltransform(), Vec(0.424,0,-0.424))), 0, 1, 1, 1)
	end
	if launched and not deletebladesfororbit then
		groupIndex = 2
		for i=1, #blade do
			bladecentertransform[i] = GetBodyTransform(blade[i])
			if GetPlayerVehicle() ~= 0 then vehicle = GetPlayerVehicle() target = TransformToParentPoint(GetVehicleTransform(vehicle), GetVehicleDriverPos(vehicle)) targettransform = GetVehicleTransform(vehicle) else target = toolpos() targettransform = GetPlayerCameraTransform() end
			if GetTime() > launchtimer[i] + 2 and bladefollowmode == 1 then force = math.min(-0.2*GetBodyMass(blade[i]), -0.2*GetBodyMass(blade[i])*(100/(VecLength(VecSub(target, GetBodyTransform(blade[i]).pos))^2))) else force = -0.2*GetBodyMass(blade[i]) end
			if bladefollowmode == 1 or GetTime() < launchtimer[i] + 0.5 then ApplyBodyImpulse(blade[i], bladecentertransform[i].pos, VecAdd(Vec(0,GetBodyMass(blade[i])*(10.02/60)*(dt*60),0), QuatRotateVec(QuatLookAt(bladecentertransform[i].pos, target), Vec(0,0,force)))) end
			--rigidfollowvelocity = GetBodyVelocity(blade[i])
			if bladefollowmode == 2 then
				rigidfollowvelocity[i] = math.max(rigidfollowvelocity[i] + (force/GetBodyMass(blade[i])), -20*GetBodyMass(blade[i])-(VecLength(GetPlayerVelocity())^1.2))
				if GetTime() > launchtimer[i] + 0.5 then
					if pulling then
						pullforce = -10
						rigidfollowvelocity[i] = rigidfollowvelocity[i] + pullforce*dt*2
					else
						pullforce = 0
					end
					SetBodyVelocity(blade[i], QuatRotateVec(QuatLookAt(bladecentertransform[i].pos, target), Vec(0,0,rigidfollowvelocity[i]*(dt*60))))
				end
			elseif bladefollowmode == 3 then
				if not multiblade or #blade == 1 then spinmult = 1.5 else spinmult = 1 end
				spinchange[i] = math.deg((25*spinmult*dt)/VecLength(VecSub(targettransform.pos, GetBodyTransform(blade[i]).pos))) --(40/(math.min(#blade - math.floor((i-1)/4)*4, 4)^0.5))
				if i == totalblades[groupIndex-1] + 1 then
					spin[i] = round((spin[i] + spinchange[i])%360, 0.01)
				else
					if i > totalblades[10] then numInGroup = #blade - totalblades[10] bladeRingSpinOffset = 0 else numInGroup = numingroup[groupIndex] bladeRingSpinOffset = (bladeringspinoffset[groupIndex]*((dt*60)^0.75)) end
					if spin[i-1] > spin[i] then spindiff = round(spin[i-1] - spin[i], 0.01) else spindiff = round((360-spin[i])+spin[i-1], 0.01) end
					spinoffset = 360/(numInGroup-bladeRingSpinOffset)
					--ease-in alignment --spin[totalblades[groupIndex-1] + 1] - spinoffset*(i-(totalblades[groupIndex-1] + 1))
					--if spindiff > (spinoffset) - (spinoffset)*0.01 and spindiff < (spinoffset) then spin[i] = (spin[i] + spinchange[i])%360 else spin[i] = (spin[i] + spinchange[i] + (spindiff-(spinoffset))*dt*5)%360 end --old
					spin[i] = round((spin[i] + spinchange[i] + (spindiff-(spinoffset))*dt*lowfpsbladealignmentcompensation)%360, 0.01)
					--instant alignment
					--spin[i] = (spin[i] + spinchange[i] - spindiff)%360
				end
				orbitoffset[i] = (1 + (groupIndex-2)*0.6)^1.3123
				if GetPlayerVehicle() ~= 0 then
					local upperbound, lowerbound = GetBodyBounds(GetVehicleBody(GetPlayerVehicle()))
					upperbound = Vec(upperbound[1], 0, upperbound[3])
					lowerbound = Vec(lowerbound[1], 0, lowerbound[3])
					vehicleorbitoffset = (VecLength(VecSub(upperbound, lowerbound))/2) - 2
					verticalorbitoffset = GetVehicleDriverPos(GetPlayerVehicle())[2] - 0.5
					vehicleorbitxoffset, throwaway, vehicleorbitzoffset = 0,0,0
				else
					vehicleorbitoffset = 0
					verticalorbitoffset = 0
					vehicleorbitxoffset = 0
					vehicleorbitzoffset = 0
				end --GetQuatEuler(GetVehicleTransform(GetPlayerVehicle()).rot)
				bladeconstraindist = 3.5*orbitoffset[i] + vehicleorbitoffset
				--if VecLength(VecSub(targettransform.pos, GetBodyTransform(blade[i]).pos)) > 4*orbitoffset[i] - 0.1 and VecLength(VecSub(targettransform.pos, GetBodyTransform(blade[i]).pos)) < 4*orbitoffset[i] + 0.1 then bladeconstraindist = 4*orbitoffset[i] else bladeconstraindist = ((14*orbitoffset[i])+VecLength(VecSub(targettransform.pos, GetBodyTransform(blade[i]).pos)))/5 end
				if debug then
					DebugWatch("vehiclerot", {vehicleorbitxoffset, throwaway, vehicleorbitzoffset})
					DebugWatch("spinchange"..i, spinchange[i])
					DebugWatch("spin"..i, spin[i])
					if i >= 2 then DebugWatch("spindiff "..i.."-"..(i-1), spindiff) end
					if i == totalblades[groupIndex-1] + 1 then crossr,crossg,crossb = 1,0,0 else crossr,crossg,crossb = 1,1,1 end
					DebugCross(VecAdd(TransformToParentVec(Transform(targettransform.pos, QuatEuler(0,spin[i],0)), Vec(0,-0.5,bladeconstraindist)), targettransform.pos), crossr, crossg, crossb)
					if i > totalblades[groupIndex-1] + 2 then
						if spin[totalblades[groupIndex-1] + 1] < spin[i] then spindifffirsttolast = (spin[totalblades[groupIndex-1] + 1] - spin[i]) else spindifffirsttolast = ((360-spin[totalblades[groupIndex-1] + 1])+spin[i]) end
						DebugWatch("spindiff "..i.."-"..(totalblades[groupIndex-1] + 1), spindifffirsttolast)
					end
					DebugWatch("numInGroup", numInGroup)
					DebugWatch("bladeRingSpinOffset", bladeRingSpinOffset)
				end
				--if GetPlayerVehicle() == 0 then orbittilt = clamp(realtilt, -45, 45) else orbittilt = 0 end
				orbittilt = 0
				local l, yrot, l = GetQuatEuler(GetPlayerCameraTransform().rot)
				DebugWatch("tilt", orbittilt*math.cos(math.rad(spin[i]-yrot)))
				ConstrainPosition(0, blade[i],VecAdd(TransformToParentVec(Transform(targettransform.pos, QuatEuler(-vehicleorbitzoffset*(math.sin(math.rad(spin[i]))), spin[i], -vehicleorbitxoffset*(math.sin(math.rad(spin[i]))))), QuatRotateVec(QuatEuler(orbittilt*math.cos(math.rad(spin[i]-yrot)),-90,0), Vec(0,-0.5 + verticalorbitoffset,bladeconstraindist + math.abs(orbittilt/90)))), targettransform.pos), bladecentertransform[i].pos)
				bladerot[i] = (bladerot[i] + 720*dt*2)%360
				--DebugWatch("bladerot", bladerot)
				ConstrainOrientation(0, blade[i], QuatRotateQuat(QuatEuler(0,bladerot[i],0), QuatEuler(orbittilt*bladerot[i],0,0)), bladecentertransform[i].rot)
				DebugWatch("rot", GetQuatEuler(GetBodyTransform(blade[i]).rot))
				if i == totalblades[groupIndex] and groupIndex ~= 11 then groupIndex = groupIndex + 1 end
			end
			if bladefollowmode ~= 3 then SetBodyAngularVelocity(blade[i], TransformToParentVec(bladecentertransform[i], Vec(0,30,0))) end
		end
	end
	if (not launched or (multiblade and VecLength(VecSub(target, GetBodyTransform(closestblade).pos)) > 2)) and GetBool("game.player.canusetool") and (GetString("game.player.tool") == "blade_launcher" or GetString("game.player.tool") == "blade_launcher2") and not off and GetTime() > nocutlaunchtimer + 0.15 and not (options or optionsshown) and GetTime() > optionsclosetimer + 0.5 and not disableblade and GetPlayerVehicle() == 0 and not (bladefollowmode == 3 and #blade > 30) then
		anchor = Transform(VecAdd(GetShapeWorldTransform(staticblade).pos, TransformToParentVec(GetShapeWorldTransform(staticblade), Vec(0.45,0.45,0))), GetShapeWorldTransform(staticblade).rot)
		offset = 0
		bladecancut = true
		if not speedup then cutamount = 0.25 else cutamount = 1 end
		--if reducecutting then cutreduce = 0.125 else cutreduce = 1 end
		for i=1, math.max(round(cutaccuracy*cutamount, 1), 2) do
			offset = offset + (360/(cutaccuracy*cutamount))
			cutcount = MakeHole(VecAdd(anchor.pos, TransformToParentVec(tooltransform(), QuatRotateVec(QuatEuler(0,offset+angle,0), Vec(0,0,0.45)))), 0.15, 0.125, 0.1)
			cutcount2 = MakeHole(VecAdd(anchor.pos, TransformToParentVec(tooltransform(), QuatRotateVec(QuatEuler(0,offset+angle,0), Vec(0,0,0.25)))), 0.15, 0.125, 0.1)
			if debug then
				DebugCross(VecAdd(anchor.pos, TransformToParentVec(tooltransform(), QuatRotateVec(QuatEuler(0,offset+angle,0), Vec(0,0,0.45))))) --anchor, QuatRotateVec(QuatEuler(0,GetShapeWorldTransform(staticblade).rot[2]+offset,0), Vec(0,0,0.5))
				DebugCross(VecAdd(anchor.pos, TransformToParentVec(tooltransform(), QuatRotateVec(QuatEuler(0,offset+angle,0), Vec(0,0,0.25)))))
			end
			if cutcount + cutcount2 > 0 then
				speedup = true
				speeduptimer = GetTime()
				local cutcountfinal = cutcount + cutcount2
				bladeParticles(anchor.pos, cutcountfinal, cutcount, cutcount2)
				if GetTime() > cutsoundtimer + 0.1 then
					PlaySound(cut, VecAdd(anchor.pos, TransformToParentVec(tooltransform(), QuatRotateVec(QuatEuler(0,offset+angle,0), Vec(0,0,0.45)))), (0.15*math.min(1,cutcountfinal/3))*volume*1.5)
					cutsoundtimer = GetTime()
				end
			end
		end
		cutfreqdelay = GetTime()
	else bladecancut = false
	end
	if launched then
		for i=1, #blade do
			if VecLength(VecSub(target, GetBodyTransform(blade[i]).pos)) > 2 or VecLength(GetBodyVelocity(blade[i])) < 2 then
				cangrab[i] = true
			end
		end
	end
	if realtilt < tilt - 0.5 then
		realtilt = realtilt + math.max((tilt-realtilt)/10, 1)
		tilting = true
	elseif realtilt > tilt + 0.5 then
		realtilt = realtilt - math.max((realtilt-tilt)/10, 1)
		tilting = true
	else
		realtilt = round(realtilt, 15)
		tilting = false
	end
	if speedup and GetTime() < speeduptimer + 0.25 and speedupval < 2 then 
		speedupval = speedupval + 0.025
	elseif GetTime() > speeduptimer + 0.25 and speedupval > 1 then
		speedup = false
		speedupval = speedupval - 0.025
	end
end

function bladeParticles(anchorpos, cutintensity, cut1, cut2)
	ParticleReset()
	ParticleType("plain")
	ParticleTile(6)
	ParticleSticky(0, 0)
	ParticleRadius(0.01, 0.01)
	ParticleAlpha(1)
	ParticleEmissive(10, 10)
	ParticleColor(1, 0.75, 0.25, 1, 0.25, 0.25)
	ParticleGravity(-10, -10)
	for i = 1, 2*cutintensity do
		if i <= cut1*2 then sparkoffset = 0.5 else sparkoffset = 0.3 end
		SpawnParticle(VecAdd(anchorpos, TransformToParentVec(tooltransform(), QuatRotateVec(QuatEuler(0,offset+angle,0), Vec(0,0,sparkoffset)))), VecAdd(VecScale(GetPlayerVelocity(), 0.5), VecScale(TransformToParentVec(tooltransform(), QuatRotateVec(QuatEuler(0,offset+angle,0), Vec(1,math.random(-10,10)/80,math.random(-10,10)/80))), math.min((speedupval*launchpower)*5, 15))), math.random(10,25)/20)
	end
end

function toolpos()
	if GetToolBody() ~= 0 then
		local toolbody = GetBodyTransform(GetToolBody())
		return toolbody.pos
	end
end

function bladepos()
	return VecAdd(GetShapeWorldTransform(staticblade).pos, TransformToParentVec(GetShapeWorldTransform(staticblade), Vec(0.45,0.45,0)))
end

function tooltransform()
	if GetToolBody() ~= 0 then
		local toolbody = GetBodyTransform(GetToolBody())
		return toolbody
	end
end

function addtables(t1,t2)
	for i=1,#t2 do
	   t1[#t1+1] = t2[i]
	end
	return t1
end

function tabletostring(table)
	local string = "{"
	for i=1, #table do
		if i==1 then string = string..table[i] else string = string..", "..table[i] end
	end
	return string.."}"
end

function UiLine(x1, y1, x2, y2, width, color)
    local angle = math.atan2(x2-x1, y2-y1)*180/math.pi
    local distance = distanceFrom(x1,y1,x2,y2)

    UiPush()
        if color ~= nil then UiColor(color.r, color.g, color.b, color.a) end
         UiTranslate(x1-width/2, y1-width/2)
        UiRotate(angle)
        UiRect(width, distance)
    UiPop()
end

function distanceFrom(x1,y1,x2,y2) return math.sqrt((x2 - x1) ^ 2 + (y2 - y1) ^ 2) end

function clamp(val, min, max)
	return math.min(max, math.max(min, val))
end

function draw(dt)
	if not (options or opacity > 0) then
		if (GetString("game.player.tool") == "blade_launcher" or GetString("game.player.tool") == "blade_launcher2") then
			--DebugWatch("disableblade", disableblade)
			if (not launched or multiblade) and (disableblade or GetTime() < stopbladetimer + 0.5) and not dontshowagain then
				UiPush()
					UiTranslate(UiCenter(), UiMiddle()+50)
					UiAlign("center top")
					UiFont("bold.ttf", 40)
					UiTextOutline(0,0,0,1,0.8)
					UiText("Handheld blade cutting has been reduced to reduce lag")
					UiTranslate(0, 40)
					UiText("(Likely because the blade is near a large object)")
					UiTranslate(0, 40)
					UiText("Press X or hold Grab + Usetool to never show this again")
				UiPop()
				showingwarning = true
			else
				showingwarning = false
			end
			UiPush()
				if GetString("game.player.canusetool") and GetPlayerVehicle() == 0 then
					UiPush()
						UiTranslate(UiCenter(), UiHeight()-22)
						UiFont("bold.ttf", 26)
						UiAlign("center middle")
						local w,h = UiGetTextSize("BLADE LAUNCHER")
						UiColor(r,g,b,1)
						UiRect(w+6,h+3)
						UiColor(1,1,1,1)
						UiTextOutline(0,0,0,1,0.8)
						UiText("BLADE LAUNCHER")
					UiPop()
				end
				if not (not launched and GetPlayerVehicle() ~= 0) then
					if GetPlayerVehicle() == 0 then UiTranslate(UiCenter(), UiHeight()-50) else UiTranslate(UiCenter(), UiHeight()-85) end
					UiFont("bold.ttf", 30)
					UiTextOutline(0,0,0,1,0.9)
					UiAlign("center middle")
					UiText("Press O for options")
					if not launched and (GetString("game.player.tool") == "blade_launcher" or GetString("game.player.tool") == "blade_launcher2") and GetPlayerVehicle() == 0 then
						UiTranslate(0,-30)
						UiFont("bold.ttf", 30)
						UiTextOutline(0,0,0,1,0.9)
						UiAlign("center middle")
						UiText("Blade Tilt: "..tilt.." degrees")
					elseif launched then
						UiTranslate(0,-32)
						UiPush()
							UiFont("bold.ttf", 30)
							UiColor(1,1,1,1)
							UiTextOutline(0,0,0,1,0.9)
							UiAlign("center middle")
							if #blade >= 1 and ((#blade < 6 and bladefollowmode ~= 3) or (#blade < 5)) then
								disttext = "Blade Distance: "
								for i=1, #blade do
									if bladefollowmode ~= 3 then
										bladedist = VecLength(VecSub(target, GetBodyTransform(blade[i]).pos))
									else
										bladedist = VecLength(VecSub(targettransform.pos, GetBodyTransform(blade[i]).pos))
									end
									if disttext ~= "Blade Distance: " then disttext = disttext.."m, " end
									if round(bladedist,0.1) - round(bladedist,1) == 0 then disttext = disttext..round(bladedist,0.1)..".0" else disttext = disttext..round(bladedist,0.1) end
								end
								UiText(disttext.."m")
							else
								if bladefollowmode == 3 then
									if #blade > 4 then disttext = "Blade Rings At Distances: " else disttext = "Blade Ring At Distance: " end
									for i=1, #totalblades do
										groupIndex2 = i+1
										if #blade > totalblades[groupIndex2-1] then
											if disttext ~= "Blade Rings At Distances: " and disttext ~= "Blade Ring At Distance: " then disttext = disttext..", " end
											if #blade >= totalblades[groupIndex2] then
												disttext = disttext..numingroup[groupIndex2].." - "..orbitdists[groupIndex2].."m"
											else
												disttext = disttext..(#blade-totalblades[groupIndex2-1]).." - "..orbitdists[groupIndex2].."m"
											end
										end
									end
									UiText(disttext)
								else
									bladedist = VecLength(VecSub(target, GetBodyTransform(closestblade).pos))
									if round(bladedist,0.1) - round(bladedist,1) == 0 then bladedist = round(bladedist,0.1)..".0" else bladedist = round(bladedist,0.1) end
									UiText("Blades: "..#blade..", Closest Blade: "..bladedist.."m")
								end
							end
						UiPop()
						UiTranslate(0,2)
						--UiPush()
						--	local rx, ry, rz = GetQuatEuler(GetPlayerCameraTransform().rot)
						--	local lineanchorx = UiCenter()
						--	local lineanchory = -UiHeight()-150
						--	for i=1, #blade do
						--		UiLine(lineanchorx,lineanchory,lineanchorx+20,lineanchory+20, 10, {1,1,1,1}) --10*math.cos(math.atan(GetPlayerCameraTransform().pos[1]-GetBodyTransform(blade[i]).pos[1], GetPlayerCameraTransform().pos[3]-GetBodyTransform(blade[i]).pos[3])), math.sin(rx)
						--	end
						-- UiPop()
					end
					UiTranslate(0, -30)
					if bladefollowmode ~= 3 or #blade < 5 then UiText(followmodes[bladefollowmode]) else UiText(followmodes[bladefollowmode].." - "..#blade.." Blades") end
					UiTranslate(0, -30)
					if GetPlayerCameraTransform().pos[2] > 1000 then UiText(round(GetPlayerCameraTransform().pos[2], 1).."m in the air") end
				end
				UiTranslate(0,-300)
				--if frameratewarntimer ~= nil and GetTime() > 1 and GetTime() > frameratewarntimer + 1 and bladecancut and not dontshowagain and #blade < 15 then
				--	UiFont("bold.ttf", 40)
				--	UiTextOutline(0, 0, 0, math.min(0.5, (GetTime() - (frameratewarntimer+1))*2), 0.9)
				--	UiColor(1,1,1,math.min(0.5, (GetTime() - (frameratewarntimer+1))*2))
				--	UiText("If your framerate is low, press middle mouse")
				--	UiTranslate(0,40)
				--	UiText("to disable the blade and stop the lag")
				--	UiFont("bold.ttf", 35)
				--	UiTranslate(0,40)
				--	UiText("(press middle mouse again to re-enable the blade)")
				--	UiTranslate(0,40)
				--	UiText("(try to stay away from large dynamic objects when the blade is on)")
				--	framewarning = true
				--	UiTranslate(0,40)
				--	UiText("(press x to not show this again)")
				--	framewarningbrightness = math.min(1, (GetTime() - (frameratewarntimer+1))*2)
				--	if InputPressed("x") then dontshowagain = true SetBool("savegame.mod.dontshowframeratewarning", true) end
				--elseif framewarning then
				--	framewarningbrightness = framewarningbrightness - dt*2
				--	UiFont("bold.ttf", 40)
				--	UiTextOutline(0, 0, 0, math.min(0.5, framewarningbrightness), 0.9)
				--	UiColor(1,1,1,math.min(0.5, framewarningbrightness))
				--	UiText("If your framerate is low, press middle mouse")
				--	UiTranslate(0,40)
				--	UiText("to disable the blade and stop the lag")
				--	UiFont("bold.ttf", 35)
				--	UiTranslate(0,40)
				--	UiText("(press middle mouse again to re-enable the blade)")
				--	UiTranslate(0,40)
				--	UiText("(try to stay away from large dynamic objects when the blade is on)")
				--	UiTranslate(0,40)
				--	UiText("(press x to not show this again)")
				--	if framewarningbrightness <= 0 then framewarningbrightness = 0 framewarning = false end
				--	if InputPressed("x") then dontshowagain = true SetBool("savegame.mod.dontshowframeratewarning", true) end
				--end
				if debug then
					DebugWatch("framerate", 1/GetTimeStep())
					DebugWatch("frameratethreshold", avgframerate*0.55)
					DebugWatch("frameratewarntimer", GetTime() - (frameratewarntimer+1))
				end
			UiPop()
		end
		if charging and bladefollowmode ~= 3 and (GetString("game.player.tool") == "blade_launcher" or GetString("game.player.tool") == "blade_launcher2") and GetPlayerVehicle() == 0 then
			UiPush()
				UiAlign("center middle")
				UiTranslate(UiCenter()+math.random(-1*(launchpower-1),1*(launchpower-1)), UiMiddle()+20+math.random(-1*(launchpower-1),1*(launchpower-1)))
				UiColor(1,1,1,1)
				UiRect(104, 20)
				UiColor(0,0,0,1)
				UiRect(100, 16)
				UiColor(r,g,b,1)
				UiRect((launchpower-1)*46, 10)
			UiPop()
		end
	end
	
		--
		--
		-- OPTIONS UI
		--
		--

    if options or opacity > 0 then
		if optionspage == 1 then
        	UiPush()
        	    if opacity < 1 and options then opacity = opacity + 2*GetTimeStep() elseif opacity > 0 and not options then opacity = opacity - 2*GetTimeStep() end
        	    UiColorFilter(1, 1, 1, opacity)
        	    SetTimeScale(1-(opacity*0.9))
				UiMakeInteractive()
				UiTextOutline(0,0,0,1,0.9)
        	    UiPush()
        	        UiAlign("center middle")
        	        UiTranslate(UiCenter(), UiMiddle())
        	        UiColor(0,0,0,0.5)
        	        UiRect(UiWidth(), UiHeight())
        	    UiPop()
        	    UiPush()
        	        UiTranslate(UiCenter(), 100)
			
        	        UiPush()
        	            UiAlign("center middle")
        	            UiFont("bold.ttf", 80)
        	            UiText("Blade Launcher")
        	        UiPop()
			
        	        UiPush()
						UiTranslate(375, -85)
						UiAlign("left top")
						UiColor(1,1,1,1)
						UiImageBox("ui/common/box-outline-fill-4.png", 570, 366, 14, 14)
						UiTranslate(1, 1)
						UiImageBox("ui/common/box-outline-fill-4.png", 568, 364, 14, 14)
						UiColor(1,1,1,1)
						UiTranslate(10, 10)
        	            UiFont("bold.ttf", 40)
						UiTextOutline(0,0,0,1,0.4)
        	            UiColor(1,1,0.6,1)
        	            UiText("Controls:")
        	            UiColor(1,1,1,1)
						UiTextOutline(0,0,0,0)
						vertcontrolsoffset = 24
        	            UiFont("bold.ttf", vertcontrolsoffset)
						UiTranslate(0, 35)
        	            UiText("- LMB - launch blade")
						UiTranslate(0, vertcontrolsoffset)
        	            UiText("- Hold LMB - charge blade")
						UiTranslate(0, vertcontrolsoffset)
        	            UiText("- Hold LMB while launched - pull blade(s) harder")
						UiTranslate(20, vertcontrolsoffset)
        	            UiText("(ALT+LMB with multiblade mode)")
						UiTranslate(-20, vertcontrolsoffset)
        	            UiText("- Hold ALT+LMB with Orbit mode - spam-launch blades")
						UiTranslate(0, vertcontrolsoffset)
        	            UiText("- RMB - instantly recall all blades")
						UiTranslate(0, vertcontrolsoffset)
        	            UiText("- Hold RMB + move camera - tilt launcher")
						UiTranslate(20, vertcontrolsoffset)
        	            UiText("(ALT+RMB while launched)")
						UiTranslate(-20, vertcontrolsoffset)
        	            UiText("- Shove held blade into object - cut")
						UiTranslate(0, vertcontrolsoffset)
        	            UiText("- MMB - toggle cutting enable/disable")
						UiTranslate(20, vertcontrolsoffset)
        	            UiText("(Greatly reduces lag when near large dynamic objects)")
						UiTranslate(-20, vertcontrolsoffset)
        	            UiText("- ALT+SCROLL - change blade mode")
						UiTranslate(0, vertcontrolsoffset)
        	            UiText("- Get within 2 meters of any blade - catch blade")
        	        UiPop()

        	        UiTranslate(0,350)
					UiTextOutline(0,0,0,1,0.9)
			
        	        UiPush()
        	            UiAlign("center middle")
        	            UiFont("bold.ttf", 40)
        	            UiColor(1,1,0.6,1)
        	            UiText("Handheld Sawblade Cutting Accuracy")
			
        	            UiTranslate(0,40)
			
        	            UiTranslate(0,15)
        	            UiColor(0,0,0,1)
						UiRect(296,56)
        	            UiColor(0.9,0.9,0.9,1)
        	            UiImageBox("ui/common/box-outline-6.png", 300, 60, 10, 10)
        	            UiTranslate(0,-15)
			
        	            UiColor(1,1,1,1)
        	            UiRect(200, 5)
        	            UiTranslate(-11,0)
        	            UiRect(3, 13)
        	            UiTranslate(11,0)
			
        	            cutaccuracyslider = (GetFloat("savegame.mod.cutaccuracy")*22.2222-100)-1
        	            cutaccuracyslider, cutaccuracydone = UiSlider("ui/common/dot.png", "x", round(cutaccuracyslider, 1), -100, 100)
        	            cutaccuracyslider = round(cutaccuracyslider, 1)
        	            SetFloat("savegame.mod.cutaccuracy", round((cutaccuracyslider+100)/22.2222, 1))
			
        	            UiTranslate((round((cutaccuracyslider/22.2222)-0.5, 1)*22.2222)+5, 0)
        	            local clickingon = InputPressed("lmb") and UiIsMouseInRect(25, 25) and not (expandlauncherselect or expandbladeselect)
        	            if InputDown("lmb") and clickingon then 
        	                UiTranslate(-17, 0)
        	                dragging = true
        	            elseif InputDown("lmb") and dragging then
        	                UiTranslate(-17, 0)
        	            else
        	                UiTranslate((-round((cutaccuracyslider/22.2222)+0.5, 1)*22.2222)-5, 0)
        	                dragging = false
        	            end
					
        	            UiTranslate(22,25)
        	            UiColor(1,1,0.7,1)
					
        	            UiFont("bold.ttf", 30)
        	            local textfull = round((cutaccuracyslider+100)/22.2222, 1)+1
        	            UiText(textfull)
					
        	            if InputDown("lmb") and (clickingon or dragging) and not (expandlauncherselect or expandbladeselect) then 
        	                UiTranslate((-round((cutaccuracyslider/22.2222)+0.5, 1)*22.2222)+12, 40)
        	            else
        	                UiTranslate(0, 40)
        	            end
        	            UiFont("bold.ttf", 45)
        	            UiText(round((cutaccuracyslider+100)/22.2222, 1)+1)
					
        	            UiTranslate(0, 30)
        	            UiColor(1,1,1,1)
        	            UiFont("bold.ttf", 30)
        	            UiText("cuts per rotation")
        	            UiTranslate(0, 30)
        	            UiText("(higher number means more accuracy but can increase lag)")
        	        UiPop()

        	        UiTranslate(0,225)

        	        UiPush()
        	            UiAlign("center middle")
        	            UiFont("bold.ttf", 40)
        	            UiColor(1,1,0.6,1)
        	            UiText("Volume")

        	            UiTranslate(0,40)

        	            UiTranslate(0,15)
        	            UiColor(0,0,0,1)
						UiRect(296,56)
        	            UiColor(0.9,0.9,0.9,1)
        	            UiImageBox("ui/common/box-outline-6.png", 300, 60, 10, 10)
        	            UiTranslate(0,-15)

        	            UiColor(1,1,1,1)
        	            UiRect(200, 5)
        	            UiTranslate(100,0)
        	            UiRect(3, 13)
        	            UiTranslate(-100,0)
					
        	            volumeslider = GetFloat("savegame.mod.volume")*100-100
        	            volumeslider, volumesliderdone = UiSlider("ui/common/dot.png", "x", round(volumeslider, 0.1), -100, 100)
        	            volumeslider = round(volumeslider, 0.2)
        	            SetFloat("savegame.mod.volume", round((volumeslider+100)/100, 0.1))

        	            UiTranslate(round(volumeslider/100, 0.1)*100, 0)
        	            local clickingon2 = InputPressed("lmb") and UiIsMouseInRect(25, 25)
        	            if InputDown("lmb") and clickingon2 then 
        	                UiTranslate(0, 0)
        	                dragging2 = true
        	            elseif InputDown("lmb") and dragging2 then
        	                UiTranslate(0, 0)
        	            else
        	                UiTranslate(-round(volumeslider/100, 0.1)*100, 0)
        	                dragging2 = false
        	            end

        	            UiTranslate(0,25)
        	            UiColor(1,1,0.7,1)

        	            UiFont("bold.ttf", 30)
        	            if round((volumeslider+100)/200, 0.1) ~= round((volumeslider+100)/200, 1) and round((volumeslider+100)/200, 0.05) == round((volumeslider+100)/200, 0.1) then text = "0" else text = "" end
        	            local textfull = round((volumeslider+100)/200, 0.05)..text.."x"
        	            UiText(textfull)
					
        	            if InputDown("lmb") and (clickingon2 or dragging2) then 
        	                UiTranslate(-round(volumeslider/100, 0.1)*100, 40)
        	            else
        	                UiTranslate(0, 40)
        	            end
        	            UiFont("bold.ttf", 45)
        	            UiText((round((volumeslider+100)/200, 0.05)*100).."%")

        	            UiTranslate(0, 30)
        	            UiColor(1,1,1,1)
        	            UiFont("bold.ttf", 30)
        	        UiPop()

        	        UiTranslate(0,-425)

        	        UiPush() --blade dropdown
        	            UiTranslate(-200,-25)

        	            UiAlign("center top")
        	            UiFont("bold.ttf", 50)
        	            UiColor(1,1,0.6,1)
        	            UiText("Blade Style")

        	            UiTranslate(0,85)

        	            UiAlign("center middle")

        	            UiColor(1,1,1,1)
        	            UiFont("bold.ttf", 40)
        	            UiButtonHoverColor(1, 1, 1, 2)
        	            UiButtonPressColor(1,1,1,0.8)

        	            bladenames = {"Red Sharp", "Green Sharp", "Blue Sharp", "Red Rounded", "Green Rounded", "Blue Rounded"}

        	            if UiIsMouseInRect(300, 60) and InputDown("lmb") then UiTranslate(2,2) boffset2 = true else UiTranslate(0,0) boffset2 = false end
        	            UiColor(0,0,0,1)
						UiRect(296,56)
						if boffset2 then UiColor(1,1,1,0.8) else UiColor(1,1,1,1) end
        	            UiImageBox("ui/common/box-outline-6.png", 300, 60, 12, 12)
        	            if boffset2 == true then UiTranslate(-2,-2) else UiTranslate(0,0) end

        	            UiColor(1,1,1,0)
        	            UiButtonImageBox("ui/common/box-outline-6.png", 12, 12, 1, 1, 1, 0)
        	            if not expandbladeselect then 
        	                if UiTextButton("a", 300, 60) and GetTime() > clickedtimer + 0.1 then
        	                    expandbladeselect = true
        	                    clickedtimer = GetTime()
        	                end
        	            else
        	                if UiTextButton("b", 300, 60) and GetTime() > clickedtimer + 0.1 then
        	                    expandbladeselect = false
        	                    clickedtimer = GetTime()
        	                end
        	            end
        	            UiButtonImageBox("ui/common/box-outline-6.png", 12, 12, 1, 1, 1, 0.8)
        	            if UiIsMouseInRect(300, 60) and InputDown("lmb") then UiTranslate(-18,2) UiColor(1,1,1,0.8) boffset = true else UiTranslate(-20,0) UiColor(1,1,1,1) boffset = false end
        	            UiText(bladenames[GetInt("savegame.mod.bladetype")])
        	            UiTranslate(140,2)
        	            if expandbladeselect then UiImage("MOD/ui/arrow-up.png") else UiImage("MOD/ui/arrow-down.png") end
        	            UiTranslate(-140,-2)
        	            if boffset == true then UiTranslate(18,-2) else UiTranslate(20,0) end
        	            UiColor(1,1,1,1)

						bladetype = GetInt("savegame.mod.bladetype")

        	            if expandbladeselect then
        	                UiPush()
        	                    if hovernumb ~= GetInt("savegame.mod.bladetype") and firsthoverb then lasthovernumb = 0 firsthoverb = false end
        	                    UiTranslate(0,dropdownvertoffset+20)
        	                    UiColor(0,0,0,1)
        	                    UiRect(296, 56)
        	                    UiColor(1,1,1,1)

        	                    if UiTextButton(bladenames[1], 300, 60) then
        	                        expandbladeselect = false
        	                        SetInt("savegame.mod.bladetype", "1")
									bladetype = 1
        	                    end
        	                    if UiIsMouseInRect(300,60) then
        	                        hoverblade = true
        	                        if hovernumb ~= 1 then lasthovernumb = hovernumb end
        	                        hovernumb = 1
        	                    end
        	                    UiTranslate(0,dropdownvertoffset)
        	                    UiColor(0,0,0,1)
        	                    UiRect(296, 56)
        	                    UiColor(1,1,1,1)
							
        	                    if UiTextButton(bladenames[2], 300, 60) then
        	                        expandbladeselect = false
        	                        SetInt("savegame.mod.bladetype", "2")
									bladetype = 2
        	                    end
        	                    if UiIsMouseInRect(300,60) then
        	                        hoverblade = true
        	                        if hovernumb ~= 2 then lasthovernumb = hovernumb end
        	                        hovernumb = 2
        	                    end
        	                    UiTranslate(0,dropdownvertoffset)
        	                    UiColor(0,0,0,1)
        	                    UiRect(296, 56)
        	                    UiColor(1,1,1,1)
							
        	                    if UiTextButton(bladenames[3], 300, 60) then
        	                        expandbladeselect = false
        	                        SetInt("savegame.mod.bladetype", "3")
									bladetype = 3
        	                    end
        	                    if UiIsMouseInRect(300,60) then
        	                        hoverblade = true
        	                        if hovernumb ~= 3 then lasthovernumb = hovernumb end
        	                        hovernumb = 3
        	                    end
        	                    UiTranslate(0,dropdownvertoffset)
        	                    UiColor(0,0,0,1)
        	                    UiRect(296, 56)
        	                    UiColor(1,1,1,1)
							
        	                    if UiTextButton(bladenames[4], 300, 60) then
        	                        expandbladeselect = false
        	                        SetInt("savegame.mod.bladetype", "4")
									bladetype = 4
        	                    end
        	                    if UiIsMouseInRect(300,60) then
        	                        hoverblade = true
        	                        if hovernumb ~= 4 then lasthovernumb = hovernumb end
        	                        hovernumb = 4
        	                    end
        	                    UiTranslate(0,dropdownvertoffset)
        	                    UiColor(0,0,0,1)
        	                    UiRect(296, 56)
        	                    UiColor(1,1,1,1)
							
        	                    if UiTextButton(bladenames[5], 300, 60) then
        	                        expandbladeselect = false
        	                        SetInt("savegame.mod.bladetype", "5")
									bladetype = 5
        	                    end
        	                    if UiIsMouseInRect(300,60) then
        	                        hoverblade = true
        	                        if hovernumb ~= 5 then lasthovernumb = hovernumb end
        	                        hovernumb = 5
        	                    end
        	                    UiTranslate(0,dropdownvertoffset)
        	                    UiColor(0,0,0,1)
        	                    UiRect(296, 56)
        	                    UiColor(1,1,1,1)
							
        	                    if UiTextButton(bladenames[6], 300, 60) then
        	                        expandbladeselect = false
        	                        SetInt("savegame.mod.bladetype", "6")
									bladetype = 6
        	                    end
        	                    if UiIsMouseInRect(300,60) then
        	                        hoverblade = true
        	                        if hovernumb ~= 6 then lasthovernumb = hovernumb end
        	                        hovernumb = 6
        	                    end

        	                    UiAlign("center bottom")
        	                    UiTranslate(0,31)
        	                    if not UiIsMouseInRect(302,362) then
        	                        hoverblade = false
        	                        if hovernumb ~= GetInt("savegame.mod.bladetype") then lasthovernumb = hovernumb end
        	                        hovernumb = GetInt("savegame.mod.bladetype")
        	                        if InputPressed("lmb") then
        	                            expandbladeselect = false
        	                        end
        	                    end
        	                UiPop()
        	            end

        	            if lasthovernumb ~= cachedlastimgb then
        	                cachedlastimgb = lasthovernumb
        	                ImageFadeIn(true)
        	            end

        	            UiTranslate(-160,240)
        	            UiAlign("right middle")

        	            if firsthoverb then UiColor(1,1,1,1) else UiColor(1,1,1,ImageFadeIn()) end

        	            bladeimagename = {"blade_red_t.png", "blade_green_t.png", "blade_blue_t.png", "blade2_red_t.png", "blade2_green_t.png", "blade2_blue_t.png"}
        	            if hoverblade then UiImage("MOD/previews/"..bladeimagename[hovernumb]) else UiImage("MOD/previews/"..bladeimagename[GetInt("savegame.mod.bladetype")]) end
        	        UiPop()

        	        UiPush() --launcher dropdown
        	            UiTranslate(200,-25)

        	            UiAlign("center top")
        	            UiFont("bold.ttf", 50)
        	            UiColor(1,1,0.6,1)
        	            UiText("Launcher Color")

        	            UiTranslate(0,85)

        	            UiAlign("center middle")

        	            UiColor(1,1,1,1)
        	            UiFont("bold.ttf", 40)
        	            UiButtonHoverColor(1, 1, 1, 2)

        	            launchername = {"Red", "Green", "Blue"}

        	            if UiIsMouseInRect(160, 60) and InputDown("lmb") then UiTranslate(2,2) loffset2 = true else UiTranslate(0,0) loffset2 = false end
        	            UiColor(0,0,0,1)
						UiRect(156,56)
						if loffset2 then UiColor(1,1,1,0.8) else UiColor(1,1,1,1) end
        	            UiImageBox("ui/common/box-outline-6.png", 160, 60, 12, 12)
        	            if loffset2 == true then UiTranslate(-2,-2) else UiTranslate(0,0) end
					
        	            UiColor(1,1,1,0)
        	            UiButtonImageBox("ui/common/box-outline-6.png", 12, 12, 1, 1, 1, 0)
        	            if not expandlauncherselect then 
        	                if UiTextButton("a", 160, 60) and GetTime() > clickedtimer + 0.1 then
        	                    expandlauncherselect = true
        	                    clickedtimer = GetTime()
        	                end
        	            else
        	                if UiTextButton("b", 160, 60) and GetTime() > clickedtimer + 0.1 then
        	                    expandlauncherselect = false
        	                    clickedtimer = GetTime()
        	                end
        	            end
        	            UiButtonImageBox("ui/common/box-outline-6.png", 12, 12, 1, 1, 1, 0.8)
        	            if UiIsMouseInRect(160, 60) and InputDown("lmb") then UiTranslate(-18,2) UiColor(1,1,1,0.8) loffset = true else UiTranslate(-20,0) UiColor(1,1,1,1) loffset = false end
        	            UiText(launchername[GetInt("savegame.mod.launchertype")])
        	            UiTranslate(70,2)
        	            if expandlauncherselect then UiImage("MOD/ui/arrow-up.png") else UiImage("MOD/ui/arrow-down.png") end
        	            UiTranslate(-70,-2)
        	            if loffset == true then UiTranslate(18,-2) else UiTranslate(20,0) end
        	            UiColor(1,1,1,1)

						launchertype = GetInt("savegame.mod.launchertype")

        	            if expandlauncherselect then
        	                UiPush()
        	                    if hovernuml ~= GetInt("savegame.mod.launchertype") and firsthoverl then lasthovernuml = 0 firsthoverl = false end
        	                    UiTranslate(0,dropdownvertoffset+20)
        	                    UiColor(0,0,0,1)
        	                    UiRect(156, 56)
        	                    UiColor(1,1,1,1)

        	                    if UiTextButton(launchername[1], 160, 60) then
        	                        expandlauncherselect = false
        	                        SetInt("savegame.mod.launchertype", "1")
									launchertype = 1
        	                    end
        	                    if UiIsMouseInRect(300,60) then
        	                        hoverlauncher = true
        	                        if hovernuml ~= 1 then lasthovernuml = hovernuml end
        	                        hovernuml = 1
        	                    end
        	                    UiTranslate(0,dropdownvertoffset)
        	                    UiColor(0,0,0,1)
        	                    UiRect(156, 56)
        	                    UiColor(1,1,1,1)
							
        	                    if UiTextButton(launchername[2], 160, 60) then
        	                        expandlauncherselect = false
        	                        SetInt("savegame.mod.launchertype", "2")
									launchertype = 2
        	                    end
        	                    if UiIsMouseInRect(300,60) then
        	                        hoverlauncher = true
        	                        if hovernuml ~= 2 then lasthovernuml = hovernuml end
        	                        hovernuml = 2
        	                    end
        	                    UiTranslate(0,dropdownvertoffset)
        	                    UiColor(0,0,0,1)
        	                    UiRect(156, 56)
        	                    UiColor(1,1,1,1)
							
        	                    if UiTextButton(launchername[3], 160, 60) then
        	                        expandlauncherselect = false
        	                        SetInt("savegame.mod.launchertype", "3")
									launchertype = 3
        	                    end
        	                    if UiIsMouseInRect(300,60) then
        	                        hoverlauncher = true
        	                        if hovernuml ~= 3 then lasthovernuml = hovernuml end
        	                        hovernuml = 3
        	                    end

        	                    UiAlign("center bottom")
        	                    UiTranslate(0,31)
        	                    if not UiIsMouseInRect(162,182) then
        	                        hoverlauncher = false
        	                        if hovernuml ~= GetInt("savegame.mod.launchertype") then lasthovernuml = hovernuml end
        	                        hovernuml = GetInt("savegame.mod.launchertype")
        	                        if InputPressed("lmb") then
        	                            expandlauncherselect = false
        	                        end
        	                    end
        	                UiPop()
        	            end

        	            if lasthovernuml ~= cachedlastimgl then
        	                cachedlastimgl = lasthovernuml
        	                ImageFadeIn2(true)
        	            end

        	            UiTranslate(160,240)
        	            UiAlign("left middle")

        	            if firsthoverl then UiColor(1,1,1,1) else UiColor(1,1,1,ImageFadeIn2()) end

        	            launcherimagename = {"launcher_red_t.png", "launcher_green_t.png", "launcher_blue_t.png"}
        	            if hoverlauncher then UiImage("MOD/previews/"..launcherimagename[hovernuml]) else UiImage("MOD/previews/"..launcherimagename[GetInt("savegame.mod.launchertype")]) end
        	        UiPop()
				UiPop()

				UiPush()
					multibladeoption = GetBool("savegame.mod.multiblade")
					if multibladeoption or GetBool("savegame.mod.hasenabledmultiblade") then
						UiAlign("center middle")
        				UiTranslate(UiCenter(), UiHeight() - 225)
						SetBool("savegame.mod.hasenabledmultiblade", true)
					else
						UiAlign("right middle")
        				UiTranslate(UiCenter() + 330, UiHeight() - 225)
						if not GetBool("savegame.mod.hasenabledmultiblade") then
							UiPush()
								UiAlign("center top")
								UiTranslate(-925, 60 + 2*(0.8^math.sin(GetTime()*15)))
								UiScale(0.8^math.sin(GetTime()*15))
								UiPush()
									UiTranslate(0, -10)
									UiScale(1)
									UiImage("MOD/ui/arrow-up-hd.png")
									UiTranslate(0, 128)
									UiRect(75, 62)
								UiPop()
								UiPush()
									UiScale(0.875)
									UiColorFilter(0,0,0,1)
									UiImage("MOD/ui/arrow-up-hd.png")
									UiTranslate(0, 128)
									UiRect(75, 62)
								UiPop()
								UiPush()
									UiTranslate(0, 12)
									UiScale(0.725)
									UiImage("MOD/ui/arrow-up-hd.png")
									UiTranslate(0, 128)
									UiRect(75, 64)
								UiPop()
							UiPop()
						end
					end
				
        	        UiColor(1,1,1,1)
        	        UiFont("bold.ttf", 60)
        	        UiButtonHoverColor(0.8, 0.8, 0.8, 0.8)
				
        	        if multibladeoption then
						multibladetext = "Multiblade Mode is On"
					elseif not GetBool("savegame.mod.hasenabledmultiblade") then
						multibladetext = "[ENABLING RECOMMENDED] Multiblade Mode is Off"
					else
						multibladetext = "Multiblade Mode is Off"
					end
        	        if multibladeoption then
        	            UiTextOutline(0,0.7,0,0.8,0.9)
        	        else
        	            UiTextOutline(0.7,0,0,0.8,0.9)
        	        end
        	        local w,h = UiGetTextSize(multibladetext)
        	        UiColor(0,0,0,1)
					UiRect(w+26,76)
        	        UiColor(1,1,1,1)
					if not GetBool("savegame.mod.hasenabledmultiblade") then UiTranslate(-13,0) end
        	        if UiTextButton(multibladetext) then
        	            if multibladeoption then
        	                SetBool("savegame.mod.multiblade", false)
        	            else
        	                SetBool("savegame.mod.multiblade", true)
        	            end
        	         end
        	        if not GetBool("savegame.mod.hasenabledmultiblade") then UiTranslate(13,2) end
        	        UiImageBox("ui/common/box-outline-6.png", w+30, 80, 10, 10)
        	    UiPop()

        	    UiPush()
        	        UiAlign("center middle")
        	        UiTranslate(UiCenter(),UiHeight() - 80)

        	        UiFont("bold.ttf", 32)
        	        UiButtonHoverColor(1, 1, 1, 2)
					UiColor(0,0,0,1)
					UiRect(196,56)
        	        UiColor(1,1,1,0.7)

        	        UiButtonImageBox("ui/common/box-outline-6.png", 12, 12, 1, 1, 1, 0.8)

        	        if UiTextButton("CLOSE (O)", 200, 60) or ((InputPressed("o") or InputPressed("pause")) and GetTime() > optionstimer + 0.1) then
						diffblade = bladeindex ~= bladetype
						difflauncher = launcherindex ~= launchertype
						if diffblade or difflauncher then
							bladeindex = bladetype
							launcherindex = launchertype
							launcherpathwithblade = "MOD/vox/launcher"..launchertypes[launcherindex]..(bladetypes[bladeindex].inlauncher)..".vox"
							launcherpathnoblade = "MOD/vox/launcher"..launchertypes[launcherindex]..".vox"
							bladepath = "MOD/vox/blade"..bladetypes[bladeindex].solo..".vox"
						end
						RegisterTool("blade_launcher", "Blade Launcher", launcherpathwithblade)
						RegisterTool("blade_launcher2", "Blade Launcher", launcherpathwithblade)
						SetBool("game.tool.blade_launcher.enabled", false)
						SetBool("game.tool.blade_launcher2.enabled", true)
						SetString("game.player.tool","blade_launcher2")
						switchBack = true
						volume = round((volumeslider+100)/100, 0.1)*0.5
						cutaccuracy = round((cutaccuracyslider+100)/22.2222, 1) + 1
						local deleteblades = multiblade ~= multibladeoption
						multiblade = multibladeoption
						if deleteblades then
							for i=1, (#blade) do
								Delete(blade[i])
							end
							blade = {}
							lastbladedist = {}
							cangrab = {}
							bladespinvolume = {}
							launchvelocity = {}
							rigidfollowvelocity = {}
							spinchange = {}
							spin = {}
							orbitoffset = {}
							bladerot = {}
							PlaySound(catch, bladepos(), 0.5*volume)
							launched = false
							grabtimer = GetTime()
						end
        	            options = false
						optionsclosetimer = GetTime()
        	        end

					UiTranslate(0, -70)
					UiButtonImageBox("ui/common/box-outline-6.png", 12, 12, 1, 1, 1, 0.8)
					if UiTextButton("PAGE 2 >", 180, 60) then
						optionspage = 2
					end
        	    UiPop()
				
				UiPush()
					UiTranslate(UiCenter() + 350,UiHeight() - 15)
					UiAlign("left bottom")
					UiColor(1,1,1,1)
					UiImageBox("ui/common/box-outline-fill-4.png", 595, 232, 14, 14)
					UiTranslate(1, -1)
					UiImageBox("ui/common/box-outline-fill-4.png", 593, 230, 14, 14)
					UiTranslate(0, -230)
					UiTranslate(10, 10)
					UiFont("bold.ttf", 40)
					UiTextOutline(0,0,0,1,0.4)
					UiColor(1,1,0.6,1)
					UiAlign("left top")
					UiText("Blade Modes (ALT+SCROLL):")
					UiColor(1,1,1,1)
					UiTextOutline(0,0,0,0)
					vertcontrolsoffset2 = 24
					UiFont("bold.ttf", vertcontrolsoffset2)
					UiTranslate(0, 47)
					UiWordWrap(582)
					if bladefollowmode == 1 then UiTextOutline(0,1,0,1,0.9) else UiTextOutline(0,0,0,0) end
					UiText("- Gravity Follow - all blades will pull towards you like they're being pulled by gravity, they can be dodged easily")
					if bladefollowmode == 1 then UiTextOutline(0,0,0,1,0.7) UiText("- Gravity Follow - all blades will pull towards you like they're being pulled by gravity, they can be dodged easily") else UiTextOutline(0,0,0,0) end
					UiTranslate(0, vertcontrolsoffset2*2 + 10)
					if bladefollowmode == 2 then UiTextOutline(0,1,0,1,0.9) else UiTextOutline(0,0,0,0) end
					UiText("- Rigid Follow - all blades will accurately seek back towards you (similar to the briefcase in Hitman), they never miss")
					if bladefollowmode == 2 then UiTextOutline(0,0,0,1,0.7) UiText("- Rigid Follow - all blades will accurately seek back towards you (similar to the briefcase in Hitman), they never miss") else UiTextOutline(0,0,0,0) end
					UiTranslate(0, vertcontrolsoffset2*2 + 10)
					if bladefollowmode == 3 then UiTextOutline(0,1,0,1,0.9) else UiTextOutline(0,0,0,0) end
					UiText("- Orbit - all blades will circle around you in rings, basically making you a blender with legs, very fun and very chaotic")
					if bladefollowmode == 3 then UiTextOutline(0,0,0,1,0.7) UiText("- Orbit - all blades will circle around you in rings, basically making you a blender with legs, very fun and very chaotic") else UiTextOutline(0,0,0,0) end
				UiPop()
        	UiPop()
		else	--page 2
        	UiPush()
			if opacity < 1 and options then opacity = opacity + 2*GetTimeStep() elseif opacity > 0 and not options then opacity = opacity - 2*GetTimeStep() end
			UiColorFilter(1, 1, 1, opacity)
			SetTimeScale(1-(opacity*0.9))
			UiMakeInteractive()
			UiTextOutline(0,0,0,1,0.9)
			UiPush()
				UiAlign("center middle")
				UiTranslate(UiCenter(), UiMiddle())
				UiColor(0,0,0,0.5)
				UiRect(UiWidth(), UiHeight())
			UiPop()
			UiPush()
				UiTranslate(UiCenter(), 100)
			
				UiPush()
					UiAlign("center middle")
					UiFont("bold.ttf", 80)
					UiText("Blade Launcher")
				UiPop()
		
				UiTranslate(-150,80)
		
				UiPush()
					modifier  = GetString("savegame.mod.modifier")
					togglecutting = GetString("savegame.mod.togglecutting")
					tiltleft = GetString("savegame.mod.tiltleft")
					tiltright = GetString("savegame.mod.tiltright")
		
					UiPush() -- Increase radius
						UiTranslate(0,  UiHeight()/2 - 350)
						UiAlign("center middle")
						UiColor(1, 1, 1, 0.7)
						UiFont("bold.ttf", 32)
						UiText("Action Modifier Key")
					UiPop()
					UiPush()
						UiTranslate(0, UiHeight()/2 - 300)
						UiAlign("center top")
						UiFont("bold.ttf", 64)
						UiColor(1, 1, 0.5)
						
						local w, h = UiGetTextSize(modifier)
						UiTranslate(0,-h/2)
		
						UiText(modifier)
					UiPop()
					UiPush() -- Decrease radius
						UiTranslate(0, UiHeight()/2 - 170)
						UiAlign("center middle")
						UiColor(1, 1, 1, 0.7)
						UiFont("bold.ttf", 32)
						UiText("Toggle Handheld Blade")
						UiTranslate(0, 33)
						UiText("Cutting Key")
					UiPop()
					UiPush()
						UiTranslate(0, UiHeight()/2 - 100)
						UiAlign("center top")
						UiFont("bold.ttf", 64)
						UiColor(1, 1, 0.5)
		
						local w, h = UiGetTextSize(togglecutting)
						UiTranslate(0,-h/2)
						
						UiText(togglecutting)
					UiPop()
				UiPop()
				UiTranslate(300,0)
				UiPush()
					UiPush() -- Value reset
						UiTranslate(0,  UiHeight()/2 - 350)
						UiAlign("center middle")
						UiColor(1, 1, 1, 0.7)
						UiFont("bold.ttf", 32)
						UiText("Tilt Launcher Left Key")
					UiPop()
					UiPush()
						UiTranslate(0, UiHeight()/2 - 300)
						UiAlign("center top")
						UiFont("bold.ttf", 64)
						UiColor(1, 1, 0.5)
		
						local w, h = UiGetTextSize(tiltleft)
						UiTranslate(0,-h/2)
		
						UiText(tiltleft)
					UiPop()
					UiPush() -- Swap paint type
						UiTranslate(0, UiHeight()/2 - 150)
						UiAlign("center middle")
						UiColor(1, 1, 1, 0.7)
						UiFont("bold.ttf", 32)
						UiText("Tilt Launcher Right Key")
					UiPop()
					UiPush()
						UiTranslate(0, UiHeight()/2 - 100)
						UiAlign("center top")
						UiFont("bold.ttf", 64)
						UiColor(1, 1, 0.5)
		
						local w, h = UiGetTextSize(tiltright)
						UiTranslate(0,-h/2)
						
						UiText(tiltright)
					UiPop()
				UiPop()
			UiPop()
		
		
			-- assign button 1
			UiPush()
				UiAlign("center middle")
				UiTranslate(UiCenter()-150,UiHeight()/2 - 55)
			
				UiColor(1,1,1,0.7)
				UiFont("bold.ttf", 36)
		
				UiButtonImageBox("ui/common/box-outline-6.png", 14, 14, 1, 1, 1, 0.5)
				UiButtonHoverColor(1, 1, 1, 2)
		
				if not assignConfirm and not assignWait then -- cancel button if/else
					if UiTextButton("ASSIGN NEW KEY") and not assignWait2 and not assignConfirm2 and not assignWait3 and not assignConfirm3 and not assignWait4 and not assignConfirm4 then --ignores click if other assign is in wait/confirm state
						fade = 1
						boundwarningwait = -1.5
						assignConfirm = false
						assignWait = true
					end
				else
					if UiTextButton("CANCEL") then
						assignWait = false
						assignConfirm = false
					end
				end
			UiPop()
		
			-- assign button 2
			UiPush()
				UiAlign("center middle")
				UiTranslate(UiCenter()-150,UiHeight()/2 + 145)
			
				UiColor(1,1,1,0.7)
				UiFont("bold.ttf", 36)
		
				UiButtonImageBox("ui/common/box-outline-6.png", 14, 14, 1, 1, 1, 0.5)
				UiButtonHoverColor(1, 1, 1, 2)
		
				if not assignConfirm2 and not assignWait2 then -- cancel button if/else
					if UiTextButton("ASSIGN NEW KEY") and not assignWait and not assignConfirm and not assignWait3 and not assignConfirm3 and not assignWait4 and not assignConfirm4 then --ignores click if other assign is in wait/confirm state
						fade = 1
						boundwarningwait = -1.5
						assignConfirm2 = false
						assignWait2 = true
					end
				else
					if UiTextButton("CANCEL") then
						assignWait2 = false
						assignConfirm2 = false
					end
				end
			UiPop()
		
			-- assign button 3
			UiPush()
				UiAlign("center middle")
				UiTranslate(UiCenter()+150,UiHeight()/2 - 55)
			
				UiColor(1,1,1,0.7)
				UiFont("bold.ttf", 36)
		
				UiButtonImageBox("ui/common/box-outline-6.png", 14, 14, 1, 1, 1, 0.5)
				UiButtonHoverColor(1, 1, 1, 2)
		
				if not assignConfirm3 and not assignWait3 then -- cancel button if/else
					if UiTextButton("ASSIGN NEW KEY") and not assignWait2 and not assignConfirm2 and not assignWait and not assignConfirm and not assignWait4 and not assignConfirm4 then --ignores click if other assign is in wait/confirm state
						fade = 1
						boundwarningwait = -1.5
						assignConfirm3 = false
						assignWait3 = true
					end
				else
					if UiTextButton("CANCEL") then
						assignWait3 = false
						assignConfirm3 = false
					end
				end
			UiPop()
		
			-- assign button 4
			UiPush()
				UiAlign("center middle")
				UiTranslate(UiCenter()+150,UiHeight()/2 + 145)
			
				UiColor(1,1,1,0.7)
				UiFont("bold.ttf", 36)
		
				UiButtonImageBox("ui/common/box-outline-6.png", 14, 14, 1, 1, 1, 0.5)
				UiButtonHoverColor(1, 1, 1, 2)
		
				if not assignConfirm4 and not assignWait4 then -- cancel button if/else
					if UiTextButton("ASSIGN NEW KEY") and not assignWait and not assignConfirm and not assignWait3 and not assignConfirm3 and not assignWait2 and not assignConfirm2 then --ignores click if other assign is in wait/confirm state
						fade = 1
						boundwarningwait = -1.5
						assignConfirm4 = false
						assignWait4 = true
					end
				else
					if UiTextButton("CANCEL") then
						assignWait4 = false
						assignConfirm4 = false
					end
				end
			UiPop()
		
			-- assign wait
			if assignWait then
				fade = fade + dt*5
				local fadeShow = (math.sin(fade/1.2)+1)/2
				UiPush()
					UiAlign("center middle")
					UiTranslate(UiCenter()-450,UiHeight()/2 - 55)
				
					UiColor(1,1,1,fadeShow + 0.1)
					UiFont("bold.ttf", 64)
					UiWordWrap(250)
					
					if boundwarningwait + 1.5 <= GetTime() then
						UiText("WAITING FOR KEY INPUT")
					else 
						UiText("KEY IS ALREADY BOUND")
					end
					if InputPressed(modifier) or InputPressed(togglecutting) or InputPressed(tiltleft) or InputPressed(tiltright) then
						boundwarningwait = GetTime()
					end
				UiPop()
			end
		
			-- assign wait2
			if assignWait2 then
				fade = fade + dt*5
				local fadeShow = (math.sin(fade/1.2)+1)/2
				UiPush()
					UiAlign("center middle")
					UiTranslate(UiCenter()-450,UiHeight()/2 + 145)
				
					UiColor(1,1,1,fadeShow + 0.1)
					UiFont("bold.ttf", 64)
					UiWordWrap(250)
					
					if boundwarningwait + 1.5 <= GetTime() then
						UiText("WAITING FOR KEY INPUT")
					else 
						UiText("KEY IS ALREADY BOUND")
					end
					if InputPressed(modifier) or InputPressed(togglecutting) or InputPressed(tiltleft) or InputPressed(tiltright) then
						boundwarningwait = GetTime()
					end
				UiPop()
			end
		
			-- assign wait3
			if assignWait3 then
				fade = fade + dt*5
				local fadeShow = (math.sin(fade/1.2)+1)/2
				UiPush()
					UiAlign("center middle")
					UiTranslate(UiCenter()+450,UiHeight()/2 - 55)
				
					UiColor(1,1,1,fadeShow + 0.1)
					UiFont("bold.ttf", 64)
					UiWordWrap(250)
					
					if boundwarningwait + 1.5 <= GetTime() then
						UiText("WAITING FOR KEY INPUT")
					else 
						UiText("KEY IS ALREADY BOUND")
					end
					if InputPressed(modifier) or InputPressed(togglecutting) or InputPressed(tiltleft) or InputPressed(tiltright) then
						boundwarningwait = GetTime()
					end
				UiPop()
			end
		
			-- assign wait4
			if assignWait4 then
				fade = fade + dt*5
				local fadeShow = (math.sin(fade/1.2)+1)/2
				UiPush()
					UiAlign("center middle")
					UiTranslate(UiCenter()+450,UiHeight()/2 + 145)
				
					UiColor(1,1,1,fadeShow + 0.1)
					UiFont("bold.ttf", 64)
					UiWordWrap(250)
					
					if boundwarningwait + 1.5 <= GetTime() then
						UiText("WAITING FOR KEY INPUT")
					else 
						UiText("KEY IS ALREADY BOUND")
					end
					if InputPressed(modifier) or InputPressed(togglecutting) or InputPressed(tiltleft) or InputPressed(tiltright) then
						boundwarningwait = GetTime()
					end
				UiPop()
			end
		
			-- assign save
			if not assignWait and assignConfirm then
				UiPush()
					UiTranslate(UiCenter()-450,UiHeight()/2 - 55)
					UiTranslate(0, -60)
					UiPush()
						UiAlign("center middle")
						UiFont("bold.ttf", 42)
						UiText("YOU PRESSED")
					UiPop()
					UiTranslate(-10, 60)
					UiPush()
						UiTranslate(0, 0)
						UiAlign("center middle")
						UiFont("bold.ttf", 64)
						UiColor(1, 1, 0.5)
		
						local w, h = UiGetTextSize(assignConfirm)
						UiTranslate((w/2) - 110,0)
		
						UiText(assignConfirm)
					UiPop()
					UiTranslate(-115,8)
					alphamult = 1
					for i=1, 7 do
						UiPush()
							UiAlign("center middle")
							UiColor(1, 1, 1, 0.125 * alphamult)
							alphamult = alphamult * 1.1
							UiRect(5, 220 - 10*i)
						UiPop()
					end
				UiPop()
		
				UiPush()
					UiAlign("center middle")
					UiTranslate(UiCenter()-450,UiHeight()/2 + 25)
				
					UiColor(0.1,1,0.1,1)
					UiFont("bold.ttf", 32)
					
					UiButtonImageBox("ui/common/box-outline-6.png", 14, 14, 1, 1, 1, 0.5)
			
					if UiTextButton("SAVE NEW KEY") then
						SetString("savegame.mod.modifier", assignConfirm)
		
						assignConfirm = false
					end
				UiPop()
			end
		
			-- assign save 2
			if not assignWait2 and assignConfirm2 then
				UiPush()
					UiTranslate(UiCenter()-450,UiHeight()/2 + 145)
					UiTranslate(0, -60)
					UiPush()
						UiAlign("center middle")
						UiFont("bold.ttf", 42)
						UiText("YOU PRESSED")
					UiPop()
					UiTranslate(-10, 60)
					UiPush()
						UiTranslate(0, 0)
						UiAlign("center middle")
						UiFont("bold.ttf", 64)
						UiColor(1, 1, 0.5)
		
						local w, h = UiGetTextSize(assignConfirm2)
						UiTranslate((w/2) - 110,0)
		
						UiText(assignConfirm2)
					UiPop()
					UiTranslate(-115,8)
					alphamult = 1
					for i=1, 7 do
						UiPush()
							UiAlign("center middle")
							UiColor(1, 1, 1, 0.125 * alphamult)
							alphamult = alphamult * 1.1
							UiRect(5, 220 - 10*i)
						UiPop()
					end
				UiPop()
		
				UiPush()
					UiAlign("center middle")
					UiTranslate(UiCenter()-450,UiHeight()/2 + 225)
				
					UiColor(0.1,1,0.1,1)
					UiFont("bold.ttf", 32)
					
					UiButtonImageBox("ui/common/box-outline-6.png", 14, 14, 1, 1, 1, 0.5)
			
					if UiTextButton("SAVE NEW KEY") then
		
						SetString("savegame.mod.togglecutting", assignConfirm2)
		
						assignConfirm2 = false
					end
				UiPop()
			end
		
			-- assign save 3
			if not assignWait3 and assignConfirm3 then
				UiPush()
					UiTranslate(UiCenter()+450,UiHeight()/2 - 55)
					UiTranslate(0, -60)
					UiPush()
						UiAlign("center middle")
						UiFont("bold.ttf", 42)
						UiText("YOU PRESSED")
					UiPop()
					UiTranslate(-10, 60)
					UiPush()
						UiTranslate(0, 0)
						UiAlign("center middle")
						UiFont("bold.ttf", 64)
						UiColor(1, 1, 0.5)
		
						local w, h = UiGetTextSize(assignConfirm3)
						UiTranslate((w/2) - 110,0)
		
						UiText(assignConfirm3)
					UiPop()
					UiTranslate(-115,8)
					alphamult = 1
					for i=1, 7 do
						UiPush()
							UiAlign("center middle")
							UiColor(1, 1, 1, 0.125 * alphamult)
							alphamult = alphamult * 1.1
							UiRect(5, 220 - 10*i)
						UiPop()
					end
				UiPop()
			
				UiPush()
					UiAlign("center middle")
					UiTranslate(UiCenter()+450,UiHeight()/2 + 25)
				
					UiColor(0.1,1,0.1,1)
					UiFont("bold.ttf", 32)
					
					UiButtonImageBox("ui/common/box-outline-6.png", 14, 14, 1, 1, 1, 0.5)
			
					if UiTextButton("SAVE NEW KEY") then
						SetString("savegame.mod.tiltleft", assignConfirm3)
		
						assignConfirm3 = false
					end
				UiPop()
			end
		
			-- assign save 4
			if not assignWait4 and assignConfirm4 then
				UiPush()
					UiTranslate(UiCenter()+450,UiHeight()/2 + 145)
					UiTranslate(0, -60)
					UiPush()
						UiAlign("center middle")
						UiFont("bold.ttf", 42)
						UiText("YOU PRESSED")
					UiPop()
					UiTranslate(-10, 60)
					UiPush()
						UiTranslate(0, 0)
						UiAlign("center middle")
						UiFont("bold.ttf", 64)
						UiColor(1, 1, 0.5)
		
						local w, h = UiGetTextSize(assignConfirm4)
						UiTranslate((w/2) - 110,0)
		
						UiText(assignConfirm4)
					UiPop()
					UiTranslate(-115,8)
					alphamult = 1
					for i=1, 7 do
						UiPush()
							UiAlign("center middle")
							UiColor(1, 1, 1, 0.125 * alphamult)
							alphamult = alphamult * 1.1
							UiRect(5, 220 - 10*i)
						UiPop()
					end
				UiPop()
		
				UiPush()
					UiAlign("center middle")
					UiTranslate(UiCenter()+450,UiHeight()/2 + 225)
				
					UiColor(0.1,1,0.1,1)
					UiFont("bold.ttf", 32)
					
					UiButtonImageBox("ui/common/box-outline-6.png", 14, 14, 1, 1, 1, 0.5)
			
					if UiTextButton("SAVE NEW KEY") then
		
						SetString("savegame.mod.tiltright", assignConfirm4)
		
						assignConfirm4 = false
					end
				UiPop()
			end
			
			if assignWait then
				if InputPressed("any") and InputLastPressedKey() ~= "" and not InputPressed(modifier) and not InputPressed(togglecutting) and not InputPressed(tiltleft) and not InputPressed(tiltright) and not InputPressed(densityfalloff) then
					assignWait = false
					assignConfirm = InputLastPressedKey()
				elseif InputPressed("mmb") and not InputPressed(modifier) and not InputPressed(togglecutting) and not InputPressed(tiltleft) and not InputPressed(tiltright) and not InputPressed(densityfalloff) then
					assignWait = false
					assignConfirm = "mmb"
				end
				
			end
		
			if assignWait2 then
				if InputPressed("any") and InputLastPressedKey() ~= "" and not InputPressed(modifier) and not InputPressed(togglecutting) and not InputPressed(tiltleft) and not InputPressed(tiltright) and not InputPressed(densityfalloff) then
					assignWait2 = false
					assignConfirm2 = InputLastPressedKey()
				elseif InputPressed("mmb") and not InputPressed(modifier) and not InputPressed(togglecutting) and not InputPressed(tiltleft) and not InputPressed(tiltright) and not InputPressed(densityfalloff) then
					assignWait2 = false
					assignConfirm2 = "mmb"
				end
				
			end
		
			if assignWait3 then
				if InputPressed("any") and InputLastPressedKey() ~= "" and not InputPressed(modifier) and not InputPressed(togglecutting) and not InputPressed(tiltleft) and not InputPressed(tiltright) and not InputPressed(densityfalloff) then
					assignWait3 = false
					assignConfirm3 = InputLastPressedKey()
				elseif InputPressed("mmb") and not InputPressed(modifier) and not InputPressed(togglecutting) and not InputPressed(tiltleft) and not InputPressed(tiltright) and not InputPressed(densityfalloff) then
					assignWait3 = false
					assignConfirm3 = "mmb"
				end
				
			end
		
			if assignWait4 then
				if InputPressed("any") and InputLastPressedKey() ~= "" and not InputPressed(modifier) and not InputPressed(togglecutting) and not InputPressed(tiltleft) and not InputPressed(tiltright) and not InputPressed(densityfalloff) then
					assignWait4 = false
					assignConfirm4 = InputLastPressedKey()
				elseif InputPressed("mmb") and not InputPressed(modifier) and not InputPressed(togglecutting) and not InputPressed(tiltleft) and not InputPressed(tiltright) and not InputPressed(densityfalloff) then
					assignWait4 = false
					assignConfirm4 = "mmb"
				end
			end
		
			UiPush()
				UiAlign("center middle")
				UiTranslate(UiCenter(),UiHeight() - 220)
		
				UiColor(1,1,1,0.7)
				UiFont("bold.ttf", 32)
				UiButtonHoverColor(1, 1, 1, 2)
		
				UiButtonImageBox("ui/common/box-outline-6.png", 10, 14, 1, 1, 1, 0.6)
		
				if UiTextButton("RESET", 160, 60) then
					SetString("savegame.mod.modifier", "alt")
					SetString("savegame.mod.togglecutting", "mmb")
					SetString("savegame.mod.tiltleft", "leftarrow")
					SetString("savegame.mod.tiltright", "rightarrow")
				end
			UiPop()
			UiPush()
        	    UiPush()
        	        UiAlign("center middle")
        	        UiTranslate(UiCenter(),UiHeight() - 80)

        	        UiFont("bold.ttf", 32)
        	        UiButtonHoverColor(1, 1, 1, 2)
					UiColor(0,0,0,1)
					UiRect(196,56)
        	        UiColor(1,1,1,0.7)

        	        UiButtonImageBox("ui/common/box-outline-6.png", 12, 12, 1, 1, 1, 0.8)

        	        if UiTextButton("CLOSE (O)", 200, 60) or ((InputPressed("o") or InputPressed("pause")) and GetTime() > optionstimer + 0.1) then
						diffblade = bladeindex ~= bladetype
						difflauncher = launcherindex ~= launchertype
						if diffblade or difflauncher then
							bladeindex = bladetype
							launcherindex = launchertype
							launcherpathwithblade = "MOD/vox/launcher"..launchertypes[launcherindex]..(bladetypes[bladeindex].inlauncher)..".vox"
							launcherpathnoblade = "MOD/vox/launcher"..launchertypes[launcherindex]..".vox"
							bladepath = "MOD/vox/blade"..bladetypes[bladeindex].solo..".vox"
						end
						RegisterTool("blade_launcher", "Blade Launcher", launcherpathwithblade)
						RegisterTool("blade_launcher2", "Blade Launcher", launcherpathwithblade)
						SetBool("game.tool.blade_launcher.enabled", false)
						SetBool("game.tool.blade_launcher2.enabled", true)
						SetString("game.player.tool","blade_launcher2")
						switchBack = true
						volume = round((volumeslider+100)/100, 0.1)*0.5
						cutaccuracy = round((cutaccuracyslider+100)/22.2222, 1) + 1
						local deleteblades = multiblade ~= multibladeoption
						multiblade = multibladeoption
						if deleteblades then
							for i=1, (#blade) do
								Delete(blade[i])
							end
							blade = {}
							lastbladedist = {}
							cangrab = {}
							bladespinvolume = {}
							launchvelocity = {}
							rigidfollowvelocity = {}
							spinchange = {}
							spin = {}
							orbitoffset = {}
							bladerot = {}
							PlaySound(catch, bladepos(), 0.5*volume)
							launched = false
							grabtimer = GetTime()
						end
        	            options = false
						optionsclosetimer = GetTime()
        	        end

					UiTranslate(0, -70)
					UiButtonImageBox("ui/common/box-outline-6.png", 12, 12, 1, 1, 1, 0.8)
					if UiTextButton("< PAGE 1", 180, 60) then
						optionspage = 1
					end
        	    UiPop()
        	UiPop()
		end
	else optionsshown = false
    end
end